//+--------------------------------------------------------------------------+
//|                                                                          |
//|                                  HAL                                     |
//|                          BassBox OpenGL plugin                           |
//|                                                                          |
//|                              Version 2.00                                |
//|                                                                          |
//+--------------------------------------------------------------------------+
//|                                                                          |
//|                         Author Patrice TERRIER                           |
//|                                                                          |
//|                         copyright(c) 2007-2017                           |
//|                                                                          |
//|                Patrice Terrier http://www.zapsolution.com                |
//|                                                                          |
//+--------------------------------------------------------------------------+
//|                  Project started on : 10-30-2007 (MM-DD-YYYY)            |
//|                        Last revised : 02-18-2017 (MM-DD-YYYY)            |
//+--------------------------------------------------------------------------+

//#include <windows.h>
//#include <mfapi.h>
//#include <gl/GL.h>
//#include <gl/GLU.h>
//#include <shlwapi.h>
//#include <math.h>
//#include "gl2.h"

#include <windows.h>
//#include "..\TCLib\stdio.h"
//#include "..\TCLib\string.h"
//#include "..\TCLib\stdlib.h"
//#include "..\TCLib\memory.h"
//#include "..\TCLib\malloc.h"
#include "..\TCLib\math.h"
//#include "..\TCLib\tchar.h"
#include "..\TCLib\Strings.cpp"

#include <gl/GL.h>
#include <gl/GLU.h>
#include "gl2.h"

typedef ULONGLONG QWORD;
#include "BBplugin.h"
#define ExportC extern "C" _declspec (dllexport)

long g_color[32];
float gsR[32], gsG[32], gsB[32];

void bbp_ColorInit() {
    g_color[0]  = bbpARGB(255, 0,44,233);  
    g_color[1]  = bbpARGB(255, 0,67,210);  
    g_color[2]  = bbpARGB(255, 0,89,187);  
    g_color[3]  = bbpARGB(255, 0,112,164); 
    g_color[4]  = bbpARGB(255, 0,135,142); 
    g_color[5]  = bbpARGB(255, 0,159,117); 
    g_color[6]  = bbpARGB(255, 0,183,88);  
    g_color[7]  = bbpARGB(255, 0,207,58);  
    g_color[8]  = bbpARGB(255, 0,231,29);  
    g_color[9]  = bbpARGB(255, 26,234,26); 
    g_color[10] = bbpARGB(255, 52,237,23); 
    g_color[11] = bbpARGB(255, 79,240,20); 
    g_color[12] = bbpARGB(255, 105,243,17);
    g_color[13] = bbpARGB(255, 126,245,14);
    g_color[14] = bbpARGB(255, 147,248,11);
    g_color[15] = bbpARGB(255, 168,250,8); 
    g_color[16] = bbpARGB(255, 189,253,5); 
    g_color[17] = bbpARGB(255, 210,255,2); 
    g_color[18] = bbpARGB(255, 233,255,0); 
    g_color[19] = bbpARGB(255, 255,255,0); 
    g_color[20] = bbpARGB(255, 255,251,0); 
    g_color[21] = bbpARGB(255, 255,235,0); 
    g_color[22] = bbpARGB(255, 255,215,0); 
    g_color[23] = bbpARGB(255, 255,196,0); 
    g_color[24] = bbpARGB(255, 255,176,0); 
    g_color[25] = bbpARGB(255, 255,156,0); 
    g_color[26] = bbpARGB(255, 253,137,0); 
    g_color[27] = bbpARGB(255, 255,117,0); 
    g_color[28] = bbpARGB(255, 255,97,0);  
    g_color[29] = bbpARGB(255, 255,78,0);  
    g_color[30] = bbpARGB(255, 255,58,0);  
    g_color[31] = bbpARGB(255, 255,0,0);   
}

void MakeColorLUT() {
    COLORBYTES bytestruct;
    for (long K = 0; K < 32; K++) {
        MoveMemory(&bytestruct, &g_color[K], sizeof(COLORBYTES));
        gsR[K] = (float)(bytestruct.R / 255.0f);
        gsG[K] = (float)(bytestruct.G / 255.0f);
        gsB[K] = (float)(bytestruct.B / 255.0f);
    }
}

ExportC long BBProc (OUT BBPLUGIN &BBP) {
    long K, KK, nLValue, nRValue, nRet = BBP_SUCCESS;

    static float PulseAngle;
    const float Cx = -717.0f, Cy = -994.0f, Cz = -71.0f;
    float fft[256], SoundBuffer[256], pulse, rAspect;
    static BBPTEXTURE mt[3];

    switch (BBP.msg) {
    case BBP_RENDER:
        float Ax, Ay, By;
        nLValue = (BBP.lpeak / 700);
        nRValue = (BBP.rpeak / 700);

        pulse = (float)(max(nLValue, nRValue) / 7.0f);
        PulseAngle = (float) fmod(PulseAngle + pulse, 360);

        glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

        glLoadIdentity();

        // Draw HAL background texture ------------------------
        glBindTexture(GL_TEXTURE_2D, mt[1].Texture);
        glBegin(GL_QUADS);
           glColor4f(0.5f,0.5f,0.5f,0.5f);
           glTexCoord2f(0.0f, 0.0f); glVertex3f(-45.0f,-45.0f,-65.0f); // Bottom Left Of The Texture And Quad
           glTexCoord2f(1.0f, 0.0f); glVertex3f( 45.0f,-45.0f,-65.0f); // Bottom Right Of The Texture And Quad
           glTexCoord2f(1.0f, 1.0f); glVertex3f( 45.0f, 45.0f,-65.0f); // Top Right Of The Texture And Quad
           glTexCoord2f(0.0f, 1.0f); glVertex3f(-45.0f, 45.0f,-65.0f); // Top Left Of The Texture And Quad
        glEnd();

        // Draw HAL lense rotating texture --------------------
        glPushMatrix();
           glRotatef(PulseAngle, 0.0f, 0.0f, 1.0f);
           glBindTexture(GL_TEXTURE_2D, mt[2].Texture);
           glBegin(GL_QUADS);
              K = (long) max(nLValue, nRValue);
              glColor4f(1.0f, gsG[K] * 0.70f, gsB[K] * 0.30f, 1.0f);
              glTexCoord2f(0.0f, 0.0f); glVertex3f(-24.5f,-24.5f,-65.0f); // Bottom Left Of The Texture And Quad
              glTexCoord2f(1.0f, 0.0f); glVertex3f( 24.5f,-24.5f,-65.0f); // Bottom Right Of The Texture And Quad
              glTexCoord2f(1.0f, 1.0f); glVertex3f( 24.5f, 24.5f,-65.0f); // Top Right Of The Texture And Quad
              glTexCoord2f(0.0f, 1.0f); glVertex3f(-24.5f, 24.5f,-65.0f); // Top Left Of The Texture And Quad
           glEnd();
        glPopMatrix();

        glTranslatef(0.0f, 0.0f, Cz);

        glRotatef(Cx, 1.0f, 1.0f, 0.0f);
        glRotatef(Cy, 0.0f, 1.0f, 0.0f);

        // This is where the magic happens:
        // BBP.fftdata returns a pointer to an area of memory containing an array of 256 singles.
        //float* fft = new float[BBP.fftsize];
        MoveMemory(&fft[0], BBP.fftdata, 256 * sizeof(float));

        // Try and smooth out the buffer by averaging the last results:
        for (long K = 0; K < 256; K++) {
            // We use SQR to bring out the midtone of the music, otherwise the spectrum is very flat.
            SoundBuffer[K] = (float) sqrt(sqrt(fft[K]) * 2);
        }

        glBindTexture(GL_TEXTURE_2D, mt[0].Texture);
        for (long Direction = -1; Direction < 2; Direction++) {
            if (Direction) {
                for (KK = 0; KK < 3; KK++) {
                    K = max((KK * 16) -1, 0);
                    glPushMatrix();
                    // The iterator K goes from 0 (deepest bass) to 255 (highest treble pitch)
                    // Ax is the distance from the center. Ay & By are width and height of the flares.
                    Ax = (float)((KK * 16) / 64.0f * 125.0f * Direction);
               
                    Ay = (float)(2 + SoundBuffer[K] * (50.0f + K / 255.0f * 70.0f)); // As K increases, the relative size of the signal
                    By = (float)(2 + SoundBuffer[K] * (50.0f + K / 255.0f * 70.0f)); // drops, so the (K / 255 * 20) compensates by boosting the signal at higher frequencies.
               
                    glColor4f(gsR[K] * SoundBuffer[K], gsG[K] * SoundBuffer[K], gsB[K] * SoundBuffer[K] + 0.1f, 0.7f);
                    glTranslatef(Ax, 0.0f, 0.0f);
                    glRotatef(Cx, 1.0f, 0.0f, 0.0f);
                    glRotatef(Cy, 0.0f, 1.0f, 0.0f);
               
                    glBegin(GL_QUADS);
                         glTexCoord2f(0.0f, 0.0f); glVertex3f(-By , Ay, 0.0f);
                         glTexCoord2f(1.0f, 0.0f); glVertex3f( By , Ay, 0.0f);
                         glTexCoord2f(1.0f, 1.0f); glVertex3f( By ,-Ay, 0.0f);
                         glTexCoord2f(0.0f, 1.0f); glVertex3f(-By ,-Ay, 0.0f);
                    glEnd();
               
                    glPopMatrix();
                }
            }
        }

        // Very important we must reassign BBP.RC to the new BBP.DC
        // Note; don//t use permanent DC, this produce better and smoother display
        wglMakeCurrent(BBP.dc, BBP.rc);
        break;

    case BBP_CREATE:
        // Retrieve plugin details
        strcpy(BBP.title, "HAL");
        strcpy(BBP.author, "Patrice Terrier");
        BBP.version  = MAKEWORD(1, 0); // Version 1.0"
        BBP.renderto = BBP_OPENGL;     // or BBP_GDIPLUS, or BBP_DIRECTX
        break;
         
    case BBP_INIT:
        // Do your code initialisation there
        bbp_ColorInit();

        glClearColor((GetRValue(BBP.backargb) + 1) / 256.0f, (GetGValue(BBP.backargb) + 1) / 256.0f, (GetBValue(BBP.backargb) + 1) / 256.0f, 1.0f);

        glShadeModel(GL_SMOOTH);      // Enables Smooth Color Shading
        glClearDepth((GLclampd) 1.0); // Depth Buffer Setup

        glDisable(GL_DEPTH_TEST); // Disable Depth Buffer

        glBlendFunc(GL_ONE, GL_ONE);

        glDepthFunc(GL_LESS);     // The Type Of Depth Test To Do

        glDisable(GL_LIGHTING);

        glEnable(GL_BLEND);
        glAlphaFunc(GL_GREATER, 0.01f);

        glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);

        glEnable(GL_TEXTURE_2D);
        Path_Combine(mt[0].FullName, TexturePath(), L"Flares.png"); mt[0].ID = 1; mt[0].Square = 0;
        Path_Combine(mt[1].FullName, TexturePath(), L"Hal.jpg"); mt[1].ID = 2; mt[1].Square = 1;
        Path_Combine(mt[2].FullName, TexturePath(), L"Hal.png"); mt[2].ID = 3; mt[2].Square = 1;
        MakeMultipleTexture(&mt[0], 3);

        MakeColorLUT();
        break;

    case BBP_SIZE:
        // The size of the view port has changed.
        RECT rc; GetClientRect(BBP.parent, &rc);
        glViewport(0, 0, Width(rc), Height(rc));

        glMatrixMode(GL_PROJECTION);
        glLoadIdentity();
        rAspect = 0.0f;
        if (Height(rc)) { rAspect = (float) Width(rc) / (float) Height(rc); }
        GL_Perspective(50.0f, rAspect, 0.01f, 5000.0f);

        glMatrixMode(GL_MODELVIEW);
        break;

    case BBP_DESTROY:
        // Free up your resources there
        DestroyTexture (&mt[0], 3);
        break;

    default:
        nRet = BBP_ERROR;
        break;
    }
    return nRet;
}

BOOL WINAPI DllMain (HINSTANCE hinstDLL, IN DWORD fdwReason, IN LPVOID lpvReserved) {
    switch (fdwReason) {
    case DLL_PROCESS_ATTACH:
        break;
    case DLL_PROCESS_DETACH:
        break;
    case DLL_THREAD_ATTACH:
        break;
    case DLL_THREAD_DETACH:
        break;
    }
    return TRUE;
}
