//+--------------------------------------------------------------------------+
//|                                                                          |
//|                               Fahrenheit                                 |
//|                          BassBox OpenGL plugin                           |
//|                                                                          |
//|                              Version 2.00                                |
//|                                                                          |
//+--------------------------------------------------------------------------+
//|                                                                          |
//|                         Author Patrice TERRIER                           |
//|                                                                          |
//|                         copyright(c) 2007-2017                           |
//|                                                                          |
//|                Patrice Terrier http://www.zapsolution.com                |
//|                                                                          |
//+--------------------------------------------------------------------------+
//|                  Project started on : 10-30-2007 (MM-DD-YYYY)            |
//|                        Last revised : 02-18-2017 (MM-DD-YYYY)            |
//+--------------------------------------------------------------------------+

//#include <windows.h>
//#include <mfapi.h>
//#include <gl/GL.h>
//#include <gl/GLU.h>
//#include <shlwapi.h>
//#include <math.h>
//#include <TimeAPI.h>
//#include "gl2.h"
//
//#include <string.h>
//#include <stdio.h>

#include <windows.h>
//#include "..\TCLib\stdio.h"
//#include "..\TCLib\string.h"
//#include "..\TCLib\stdlib.h"
//#include "..\TCLib\memory.h"
//#include "..\TCLib\malloc.h"
#include "..\TCLib\math.h"
//#include "..\TCLib\tchar.h"
#include "..\TCLib\Strings.cpp"

#include <gl/GL.h>
#include <gl/GLU.h>
#include "gl2.h"

typedef ULONGLONG QWORD;
#include "BBplugin.h"
#define ExportC extern "C" _declspec (dllexport)

#define PI         3.14159265359
#define PIx2       6.28318530718
#define RS_EPSILON 0.000001

struct TrsVec {
    float X;
    float Y;
    float Z;
};

struct TrsRgb {
    float R;
    float G;
    float B;
};

struct TrsQuat {
    float X;
    float Y;
    float Z;
    float W;
};

struct Temitter {
    float X;
    float Y;
    float Z;

    float R;
    float G;
    float B;

    float oldposX;
    float oldposY;
    float oldposZ;

    float targetposX;
    float targetposY;
    float targetposZ;
};

struct Tattracter {
    float X;
    float Y;
    float Z;

    float R;
    float G;
    float B;

    float oldposX;
    float oldposY;
    float oldposZ;

    float targetposX;
    float targetposY;
    float targetposZ;
};

struct Tion {
    float X;
    float Y;
    float Z;

    float R;
    float G;
    float B;

    float iSize;
    float iSpeed;
};

struct TrsMatrix  {
    float m[15];
};

struct rsTimer {
    float elapsed_time;           // Time since last call to tick()
    long highResCounterSupported;
    float freq;                   // high frequency system counts per second
    QWORD curr;
    QWORD prev;
};

struct PROP {
    long nIons;
    long nSize;
    long nEmitters;
    long nAttracters;
    long nSpeed;
    long nCameraSpeed;
    float rBlur;
    float rFrameTime;
    BBPTEXTURE mt[4];
    float newRGB[3];
    Temitter elist[3];
    Tattracter alist[3];
    Tion ilist[1500];
    float billboardMat[15];
    float fft[256];
    float SoundBuffer[32];
    rsTimer rsT;
};

PROP gP;

DWORD g_color[32];
float gsR[32], gsG[32], gsB[32];

void TrsTimer() {
    gP.rsT.elapsed_time = 0.0f;
    // init high- and low-res timers
    LARGE_INTEGER li;
    gP.rsT.highResCounterSupported = QueryPerformanceFrequency(&li);
    gP.rsT.freq = 1.0f / li.LowPart;
    //Sleep(1); // make Sleep() and timeGetTime() more accurate
    // get first tick for high-res timer
    QueryPerformanceCounter(&li);
    gP.rsT.curr = li.LowPart;
//    gP.rsT.lowResCurr = timeGetTime();

}

// return time elapsed since last call to tick()
float TrsTick() {
    //if (gP.rsT.highResCounterSupported) {
        gP.rsT.prev = gP.rsT.curr;
        LARGE_INTEGER li;
        QueryPerformanceCounter(&li);
        gP.rsT.curr = li.LowPart;
        if (gP.rsT.curr >= gP.rsT.prev) { gP.rsT.elapsed_time = (gP.rsT.curr - gP.rsT.prev) * gP.rsT.freq; }
    //} else {
    //    gP.rsT.lowResPrev = gP.rsT.lowResCurr;
    //    gP.rsT.lowResCurr = timeGetTime();
    //    if (gP.rsT.lowResCurr >= gP.rsT.lowResPrev) { gP.rsT.elapsed_time = (gP.rsT.lowResCurr - gP.rsT.lowResPrev) * 0.001f; }
    //}

//zTrace(STRF(gP.rsT.elapsed_time));
    return gP.rsT.elapsed_time;
}

float rsRandf(IN float x) {
    return x * (float(random()) / RAND_MAX);
}

long rsRandi(IN long x) {
    return random() % x;
}

void emitter_settargetpos(IN long i, IN float x, IN float y, IN float z) {
    gP.elist[i].oldposX = gP.elist[i].X;
    gP.elist[i].oldposY = gP.elist[i].Y;
    gP.elist[i].oldposZ = gP.elist[i].Z;
    gP.elist[i].targetposX = x;
    gP.elist[i].targetposY = y;
    gP.elist[i].targetposZ = z;
}

void emitter_interppos(IN long i, IN float n) {
    gP.elist[i].X = gP.elist[i].oldposX * (1.0f - n) + gP.elist[i].targetposX * n;
    gP.elist[i].Y = gP.elist[i].oldposY * (1.0f - n) + gP.elist[i].targetposY * n;
    gP.elist[i].Z = gP.elist[i].oldposZ * (1.0f - n) + gP.elist[i].targetposZ * n;
}

void attracter_settargetpos(IN long i, IN float x, IN float y, IN float z) {
    gP.alist[i].oldposX = gP.alist[i].X;
    gP.alist[i].oldposY = gP.alist[i].Y;
    gP.alist[i].oldposZ = gP.alist[i].Z;
    gP.alist[i].targetposX = x;
    gP.alist[i].targetposY = y;
    gP.alist[i].targetposZ = z;
}

void attracter_interppos(IN long i, IN float n) {
    gP.alist[i].X = gP.alist[i].oldposX * (1.0f - n) + gP.alist[i].targetposX * n;
    gP.alist[i].Y = gP.alist[i].oldposY * (1.0f - n) + gP.alist[i].targetposY * n;
    gP.alist[i].Z = gP.alist[i].oldposZ * (1.0f - n) + gP.alist[i].targetposZ * n;
}

void quat_set(OUT TrsQuat &quat, IN float x, IN float y, IN float z, IN float w) {
    quat.X = x;
    quat.Y = y;
    quat.Z = z;
    quat.W = w;
}

void quat_make(OUT TrsQuat &quat, IN float a, IN TrsVec v) {
    if ((a < RS_EPSILON) && (a > -RS_EPSILON)) {
       quat.X = 0.0f;
       quat.Y = 0.0f;
       quat.Z = 0.0f;
       quat.W = 1.0f;
    } else {
       a *= 0.5f;
       float sintheta = (float)sin(a);
       quat.X = sintheta * v.X;
       quat.Y = sintheta * v.Y;
       quat.Z = sintheta * v.Z;
       quat.W = (float)cos(a);
    }
}

void quat_preMult(OUT TrsQuat &quatDest, IN TrsQuat quatSrce) {
    float rX = quatDest.X;
    float rY = quatDest.Y;
    float rZ = quatDest.Z;
    float rW = quatDest.W;

    quatDest.X = rW * quatSrce.X + quatSrce.W * rX + rY * quatSrce.Z - quatSrce.Y * rZ;
    quatDest.Y = rW * quatSrce.Y + quatSrce.W * rY + rZ * quatSrce.X - quatSrce.Z * rX;
    quatDest.Z = rW * quatSrce.Z + quatSrce.W * rZ + rX * quatSrce.Y - quatSrce.X * rY;
    quatDest.W = rW * quatSrce.W - rX * quatSrce.X - rY * quatSrce.Y - rZ * quatSrce.Z;
}

void identity(OUT TrsMatrix &M) {
    M.m[0] = 1.0f; 
    M.m[1] = 0.0f;
    M.m[2] = 0.0f;
    M.m[3] = 0.0f;
    M.m[4] = 0.0f;
    M.m[5] = 1.0f;
    M.m[6] = 0.0f;
    M.m[7] = 0.0f;
    M.m[8] = 0.0f;
    M.m[9] = 0.0f;
    M.m[10] = 1.0f;
    M.m[11] = 0.0f;
    M.m[12] = 0.0f;
    M.m[13] = 0.0f;
    M.m[14] = 0.0f;
    M.m[15] = 1.0f;
}

void mat_fromQuat(OUT TrsMatrix &M, IN TrsQuat Q) {
    // must have an axis
    if ((Q.X == 0.0f) && (Q.Y == 0.0f) && (Q.Z == 0.0f)) {
        identity(M);
    } else {
        float s = 2.0f / (Q.X * Q.X + Q.Y * Q.Y + Q.Z * Q.Z + Q.W * Q.W);
        float xs = Q.X * s;
        float ys = Q.Y * s;
        float zs = Q.Z * s;
        float wx = Q.W * xs;
        float wy = Q.W * ys;
        float wz = Q.W * zs;
        float xx = Q.X * xs;
        float xy = Q.X * ys;
        float xz = Q.X * zs;
        float yy = Q.Y * ys;
        float yz = Q.Y * zs;
        float zz = Q.Z * zs;
       
        M.m[0] = 1.0f - yy - zz;
        M.m[1] = xy + wz;
        M.m[2] = xz - wy;
        M.m[3] = 0.0f;
        M.m[4] = xy - wz;
        M.m[5] = 1.0f - xx - zz;
        M.m[6] = yz + wx;
        M.m[7] = 0.0f;
        M.m[8] = xz + wy;
        M.m[9] = yz - wx;
        M.m[10] = 1.0f - xx - yy;
        M.m[11] = 0.0f;
        M.m[12] = 0.0f;
        M.m[13] = 0.0f;
        M.m[14] = 0.0f;
        M.m[15] = 1.0f;
    }
}

void hsl2rgb(IN float h, IN float s, IN float l, OUT float &r, OUT float &g, OUT float &b) {
    // hue influence
    ///////h =  (float) fmod(h, 1.0f);
    if (h > 1.0f) { h = h - 1.0f; }

    if (h < 0.166667f) { // full red, some green
        r = 1.0f;
        g = h * 6.0f;
        b = 0.0f;
    } else {
        if (h < 0.5f) { // full green
            g = 1.0f;
            if (h < 0.333333f) { // some red
                r = 1.0f - ((h - 0.166667f) * 6.0f);
                b = 0.0f;
            } else { // some blue
                b = (h - 0.333333f) * 6.0f;
                r = 0.0f;
            }
        } else {
            if (h < 0.833333f) { // full blue
                b = 1.0f;
                if (h < 0.666667f) { // some green
                    g = 1.0f - ((h - 0.5f) * 6.0f);
                    r = 0.0f;
                } else { // some red
                    r = (h - 0.666667f) * 6.0f;
                    g = 0.0f;
                }
            } else { // full red, some blue
                r = 1.0f;
                b = 1.0f - ((h - 0.833333f) * 6.0f);
                g = 0.0f;
            }
        }
    }

    // saturation influence
    r = 1.0f - (s * (1.0f - r));
    g = 1.0f - (s * (1.0f - g));
    b = 1.0f - (s * (1.0f - b));

    // luminosity influence
    r *= l;
    g *= l;
    b *= l;
}

void ion_start(IN long nion) {
    long i = rsRandi(gP.nEmitters - 1);
    gP.ilist[nion].X = gP.elist[i].X;
    gP.ilist[nion].Y = gP.elist[i].Y;
    gP.ilist[nion].Z = gP.elist[i].Z;

    float offset = gP.rFrameTime * gP.ilist[nion].iSpeed;
    switch (rsRandi(13)) {
    case 0:
        gP.ilist[nion].X += offset;
        break;
    case 1:
        gP.ilist[nion].X -= offset;
        break;
    case 2:
        gP.ilist[nion].Y += offset;
        break;
    case 3:
        gP.ilist[nion].Y -= offset;
        break;
    case 4:
        gP.ilist[nion].Z += offset;
        break;
    case 5:
        gP.ilist[nion].Z -= offset;
        break;
    case 6:
        gP.ilist[nion].X += offset;
        gP.ilist[nion].Y += offset;
        gP.ilist[nion].Z += offset;
        break;
    case 7:
        gP.ilist[nion].X -= offset;
        gP.ilist[nion].Y += offset;
        gP.ilist[nion].Z += offset;
        break;
    case 8:
        gP.ilist[nion].X += offset;
        gP.ilist[nion].Y -= offset;
        gP.ilist[nion].Z += offset;
        break;
    case 9:
        gP.ilist[nion].X -= offset;
        gP.ilist[nion].Y -= offset;
        gP.ilist[nion].Z += offset;
        break;
    case 10:
        gP.ilist[nion].X += offset;
        gP.ilist[nion].Y += offset;
        gP.ilist[nion].Z -= offset;
        break;
    case 11:
        gP.ilist[nion].X -= offset;
        gP.ilist[nion].Y += offset;
        gP.ilist[nion].Z -= offset;
        break;
    case 12:
        gP.ilist[nion].X += offset;
        gP.ilist[nion].Y -= offset;
        gP.ilist[nion].Z -= offset;
        break;
    case 13:
        gP.ilist[nion].X -= offset;
        gP.ilist[nion].Y -= offset;
        gP.ilist[nion].Z -= offset;
        break;
    }

    gP.ilist[nion].R = gP.newRGB[0];
    gP.ilist[nion].G = gP.newRGB[1];
    gP.ilist[nion].B = gP.newRGB[2];
}

float ion_normalize(OUT TrsVec &v) {
    float length = (float) sqrt(v.X * v.X + v.Y * v.Y + v.Z * v.Z);
    if (length == 0.0f) {
        v.Y = 1.0f;
    } else {
        float normalizer = 1.0f / length;
        v.X *= normalizer;
        v.Y *= normalizer;
        v.Z *= normalizer;
    }
    return length;
}

void ion_update(IN long nion) {
    long i, startOver;

    static float startOverDistance, length, temp;
    static TrsVec force, tempvec;

    force.X = 0.0f; force.Y = 0.0f; force.Z = 0.0f;

    for (i = 0; i < gP.nEmitters; i++) {
        tempvec.X = gP.ilist[nion].X - gP.elist[i].X;
        tempvec.Y = gP.ilist[nion].Y - gP.elist[i].Y;
        tempvec.Z = gP.ilist[nion].Z - gP.elist[i].Z;
        length = ion_normalize(tempvec);
        if (length > 11000.0f) { startOver = 1; }
        if (length <= 1.0f) {
            temp = 1.0f;
        } else {
            temp = 1.0f / length;
        }

        tempvec.X *= temp;
        tempvec.Y *= temp;
        tempvec.Z *= temp;

        force.X += tempvec.X;
        force.Y += tempvec.Y;
        force.Z += tempvec.Z;
    }
    startOverDistance = gP.ilist[nion].iSpeed * gP.rFrameTime;

    for (i = 0; i < gP.nAttracters; i++) {
        tempvec.X = gP.alist[i].X - gP.ilist[nion].X;
        tempvec.Y = gP.alist[i].Y - gP.ilist[nion].Y;
        tempvec.Z = gP.alist[i].Z - gP.ilist[nion].Z;
        length = ion_normalize(tempvec);
        if (length < startOverDistance) { startOver = 1; }
        if (length <= 1.0f) {
            temp = 1.0f;
        } else {
            temp = 1.0f / length;
        }
        tempvec.X *= temp;
        tempvec.Y *= temp;
        tempvec.Z *= temp;

        force.X += tempvec.X;
        force.Y += tempvec.Y;
        force.Z += tempvec.Z;
    }
    // Start this ion at an emitter if it gets too close to an attracter
    // or too far from an emitter
    if (startOver) {
        ion_start(nion);
    } else {
        ion_normalize(force);
        float offset = gP.rFrameTime * gP.ilist[nion].iSpeed;
        gP.ilist[nion].X += force.X * offset;
        gP.ilist[nion].Y += force.Y * offset;
        gP.ilist[nion].Z += force.Z * offset;
    }
}

void ion_draw(IN long nion, IN float cPulse) {
    float x = gP.ilist[nion].X * gP.billboardMat[0] + gP.ilist[nion].Y * gP.billboardMat[4] + gP.ilist[nion].Z * gP.billboardMat[8];
    float y = gP.ilist[nion].X * gP.billboardMat[1] + gP.ilist[nion].Y * gP.billboardMat[5] + gP.ilist[nion].Z * gP.billboardMat[9];
    float z = gP.ilist[nion].X * gP.billboardMat[2] + gP.ilist[nion].Y * gP.billboardMat[6] + gP.ilist[nion].Z * gP.billboardMat[10];
    glColor3f(gP.ilist[nion].R, gP.ilist[nion].G, gP.ilist[nion].B);
    glPushMatrix();
       glTranslatef(x, y, z);
       float p = (cPulse * gP.ilist[nion].iSize) * 1.5f;
       glScalef(p, p, p);
       glCallList(1);
    glPopMatrix();
}

void setTargets(IN long whichTarget) {

    long i; 
    float rChange, rPosition, rHeight, rAngle, rCosAngle, rSinAngle;

    switch (whichTarget) {
    case 0: // random
        for (i = 0; i < gP.nEmitters; i++) {
            emitter_settargetpos(i, rsRandf(1000.0f) - 500.0f, rsRandf(1000.0f) - 500.0f, rsRandf(1000.0f) - 500.0f);
        }
        for (i = 0; i < gP.nAttracters; i++) {
            attracter_settargetpos(i, rsRandf(1000.0f) - 500.0f, rsRandf(1000.0f) - 500.0f, rsRandf(1000.0f) - 500.0f);
        }
        break;

    case 1: // line (all emitters on one side, all attracters on the other)
        rPosition = -500.0f;
        rChange = 1000.0f / (float)(gP.nEmitters + gP.nAttracters - 1);
        for (i = 0; i < gP.nEmitters; i++) {
            emitter_settargetpos(i, rPosition, rPosition * 0.5f, 0.0f);
            rPosition += rChange;
        }
        for (i = 0; i < gP.nAttracters; i++) {
            attracter_settargetpos(i, rPosition, rPosition * 0.5f, 0.0f);
            rPosition += rChange;
        }
        break;

    case 2: // line (emitters and attracters staggered)
        if  (gP.nEmitters > gP.nAttracters) {
           rChange = 1000.0f / (float)(gP.nEmitters * 2 - 1);
        } else {
           rChange = 1000.0f / (float)(gP.nAttracters * 2 - 1);
        }
        rPosition = -500.0f;
        for (i = 0; i < gP.nEmitters; i++) {
            emitter_settargetpos(i, rPosition, rPosition * 0.5f, 0.0f);
            rPosition += rChange * 2.0f;
        }
        rPosition = -500.0f + rChange;
        for (i = 0; i < gP.nAttracters; i++) {
            attracter_settargetpos(i, rPosition, rPosition * 0.5f, 0.0f);
            rPosition += rChange * 2.0f;
        }
        break;

    case 3: // 2 lines (parallel)
        rChange = 1000.0f / (float)(gP.nEmitters * 2 - 1);
        rPosition = -500.0f;
        rHeight = -525.0f + (float)(gP.nEmitters * 25);
        for (i = 0; i < gP.nEmitters; i++) {
            emitter_settargetpos(i, rPosition, rHeight, -50.0f);
            rPosition += rChange * 2.0f;
        }
        rChange = 1000.0f / (float)(gP.nAttracters * 2 - 1);
        rPosition = -500.0f;
        rHeight = 525.0f - (float)(gP.nAttracters * 25);
        for (i = 0; i < gP.nAttracters; i++) {
            attracter_settargetpos(i, rPosition, rHeight, 50.0f);
            rPosition += rChange * 2.0f;
        }
        break;

    case 4: // 2 lines (skewed)
        rChange = 1000.0f / (float)(gP.nEmitters * 2 - 1);
        rPosition = -500.0f;
        rHeight = -525.0f + (float)(gP.nEmitters * 25);
        for (i = 0; i < gP.nEmitters; i++) {
            emitter_settargetpos(i, rPosition, rHeight, 0.0f);
            rPosition += rChange * 2.0f;
        }
        rChange = 1000.0f / (float)(gP.nAttracters * 2 - 1);
        rPosition = -500.0f;
        rHeight = 525.0f - (float)(gP.nAttracters * 25);
        for (i = 0; i < gP.nAttracters; i++) {
            attracter_settargetpos(i, 10.0f, rHeight, rPosition);
            rPosition += rChange * 2.0f;
        }
        break;

    case 5: // random distribution across a plane
        for (i = 0; i < gP.nEmitters; i++) {
            emitter_settargetpos(i, rsRandf(1000.0f) - 500.0f, 0.0f, rsRandf(1000.0f) - 500.0f);
        }
        for (i = 0; i < gP.nAttracters; i++) {
            attracter_settargetpos(i, rsRandf(1000.0f) - 500.0f, 0.0f, rsRandf(1000.0f) - 500.0f);
        }
        break;

    case 6: // random distribution across 2 planes
        rHeight = -525.0f + (float)(gP.nEmitters * 25.0f);
        for (i = 0; i < gP.nEmitters; i++) {
            emitter_settargetpos(i, rsRandf(1000.0f) - 500.0f, rHeight, rsRandf(1000.0f) - 500.0f);
        }
        rHeight = 525.0f - (float)(gP.nAttracters * 25.0f);
        for (i = 0; i < gP.nAttracters; i++) {
            attracter_settargetpos(i, rsRandf(1000.0f) - 500.0f, rHeight, rsRandf(1000.0f) - 500.0f);
        }
        break;

    case 7: // 2 rings (1 inside and 1 outside)
        rAngle = 0.5f;
        rChange = (float) (PIx2 / (float)(gP.nEmitters));
        for (i = 0; i < gP.nEmitters; i++) {
            rAngle += rChange;
            rCosAngle = (float)(cos(rAngle) * 200.0f);
            rSinAngle = (float)(sin(rAngle) * 200.0f);
            emitter_settargetpos(i, rCosAngle, rSinAngle, 0.0f);
        }
        rAngle = 1.5f;
        rChange = (float)(PIx2 / (float)(gP.nAttracters));
        for (i = 0; i < gP.nAttracters; i++) {
            rAngle += rChange;
            rCosAngle = (float)(cos(rAngle) * 500.0f);
            rSinAngle = (float)(sin(rAngle) * 500.0f);
            attracter_settargetpos(i, rCosAngle, rSinAngle, 0.0f);
        }
        break;

    case 8: // ring (all emitters on one side, all attracters on the other)
        rAngle = 0.5f;
        rChange = (float)(PIx2 / (float)(gP.nEmitters + gP.nAttracters));
        for (i = 0; i < gP.nEmitters; i++) {
            rAngle += rChange;
            rCosAngle = (float)(cos(rAngle) * 500.0f);
            rSinAngle = (float)(sin(rAngle) * 500.0f);
            emitter_settargetpos(i, rCosAngle, rSinAngle, 0.0f);
        }
        for (i = 0; i < gP.nAttracters; i++) {
            rAngle += rChange;
            rCosAngle = (float)(cos(rAngle) * 500.0f);
            rSinAngle = (float)(sin(rAngle) * 500.0f);
            attracter_settargetpos(i, rCosAngle, rSinAngle, 0.0f);
        }
        break;

    case 9: // ring (emitters and attracters staggered)
        if (gP.nEmitters > gP.nAttracters) {
            rChange = (float)(PIx2 / (float)(gP.nEmitters * 2));
        } else {
            rChange = (float)(PIx2 / (float)(gP.nAttracters * 2));
        }
        rAngle = 0.5;
        for (i = 0; i < gP.nEmitters; i++) {
            rCosAngle = (float)(cos(rAngle) * 500.0f);
            rSinAngle = (float)(sin(rAngle) * 500.0f);
            emitter_settargetpos(i, rCosAngle, rSinAngle, 0.0f);
            rAngle += rChange * 2.0f;
        }
        rAngle = 0.5f + rChange;
        for (i = 0; i < gP.nAttracters; i++) {
            rCosAngle = (float)(cos(rAngle) * 500.0f);
            rSinAngle = (float)(sin(rAngle) * 500.0f);
            attracter_settargetpos(i, rCosAngle, rSinAngle, 0.0f);
            rAngle += rChange * 2.0f;
        }
        break;

    case 10: // 2 points
        for (i = 0; i < gP.nEmitters; i++) {
            emitter_settargetpos(i, 500.0f, 100.0f, 50.0f);
        }
        for (i = 0; i < gP.nAttracters; i++) {
            attracter_settargetpos(i, -500.0f, -100.0f, -50.0f);
        }
        break;

    }
}

void InitObject() {
    long i;

//    srand(RAND_MAX);

    gP.nSize = 10;
    gP.nIons = ubound(gP.ilist);
    gP.nEmitters = ubound(gP.elist);
    gP.nAttracters = ubound(gP.alist);
    gP.nSpeed = 8;
    gP.nCameraSpeed = 5;
    gP.rBlur = 10.0f;

    for (i = 0; i < gP.nEmitters; i++) {
        gP.elist[i].X = rsRandf(1000.0f) - 500.0f;
        gP.elist[i].Y = rsRandf(1000.0f) - 500.0f;
        gP.elist[i].Z = rsRandf(1000.0f) - 500.0f;
    }

    for (i = 0; i < gP.nAttracters; i++) {
        gP.alist[i].X = rsRandf(1000.0f) - 500.0f;
        gP.alist[i].Y = rsRandf(1000.0f) - 500.0f;
        gP.alist[i].Z = rsRandf(1000.0f) - 500.0f;
    }

    float rTemp;
    for (i = 0; i < gP.nIons; i++) {
        gP.ilist[i].X = 0.0f;
        gP.ilist[i].Y = 0.0f;
        gP.ilist[i].Z = 0.0f;
        gP.ilist[i].R = 0.0f;
        gP.ilist[i].G = 0.0f;
        gP.ilist[i].B = 0.0f;
        rTemp = rsRandf(2.0f) + 0.4f;
        gP.ilist[i].iSize  = gP.nSize * rTemp;
        gP.ilist[i].iSpeed = gP.nSpeed * 12.0f / rTemp;
    }

    TrsTimer();
}

void bbp_ColorInit() {
    g_color[0]  = bbpARGB(255, 0,44,233);
    g_color[1]  = bbpARGB(255, 0,67,210);
    g_color[2]  = bbpARGB(255, 0,89,187);
    g_color[3]  = bbpARGB(255, 0,112,164);
    g_color[4]  = bbpARGB(255, 0,135,142);
    g_color[5]  = bbpARGB(255, 0,159,117);
    g_color[6]  = bbpARGB(255, 0,183,88);
    g_color[7]  = bbpARGB(255, 0,207,58);
    g_color[8]  = bbpARGB(255, 0,231,29);
    g_color[9]  = bbpARGB(255, 26,234,26);
    g_color[10] = bbpARGB(255, 52,237,23);
    g_color[11] = bbpARGB(255, 79,240,20);
    g_color[12] = bbpARGB(255, 105,243,17);
    g_color[13] = bbpARGB(255, 126,245,14);
    g_color[14] = bbpARGB(255, 147,248,11);
    g_color[15] = bbpARGB(255, 168,250,8);
    g_color[16] = bbpARGB(255, 189,253,5);
    g_color[17] = bbpARGB(255, 210,255,2);
    g_color[18] = bbpARGB(255, 233,255,0);
    g_color[19] = bbpARGB(255, 255,255,0);
    g_color[20] = bbpARGB(255, 255,251,0);
    g_color[21] = bbpARGB(255, 255,235,0);
    g_color[22] = bbpARGB(255, 255,215,0);
    g_color[23] = bbpARGB(255, 255,196,0);
    g_color[24] = bbpARGB(255, 255,176,0);
    g_color[25] = bbpARGB(255, 255,156,0);
    g_color[26] = bbpARGB(255, 253,137,0);
    g_color[27] = bbpARGB(255, 255,117,0);
    g_color[28] = bbpARGB(255, 255,97,0);
    g_color[29] = bbpARGB(255, 255,78,0);
    g_color[30] = bbpARGB(255, 255,58,0);
    g_color[31] = bbpARGB(255, 255,0,0);
}

void MakeColorLUT() {
    COLORBYTES bytestruct;
    for (long K = 0; K < 32; K++) {
        MoveMemory(&bytestruct, &g_color[K], sizeof(COLORBYTES));
        gsR[K] = (float)(bytestruct.R / 255.0f);
        gsG[K] = (float)(bytestruct.G / 255.0f);
        gsB[K] = (float)(bytestruct.B / 255.0f);
    }
}

void quad_draw(IN float Pulse) {
    long i, k;
    float x, y, z, p, sSize, kBuffer, rAlpha = 0.9f;
    static float UseAngle;
    UseAngle += 0.1f + Pulse; if (UseAngle > 360) { UseAngle -= 360; }

    // Draw object at the emitter / attracter center.
    GLfloat Emit[3] = {0};
    GLfloat Grid[3] = {0};
    glBindTexture(GL_TEXTURE_2D, gP.mt[1].Texture);
    // Find color for the object drawn at the emitter / attracter center.
    float rBlur = (gP.rBlur + 30.0f) * (gP.rBlur + 30.0f);
    float rBrightFactor1 = 4.0f / rBlur;
    //float rBrightFactor2 = (Pulse / 2) / rBlur;
    float rBrightFactor2 = Pulse / rBlur;
    for (i = 0; i < 100; i++) {
        Emit[0] += gP.ilist[i].R * rBrightFactor1;
        Emit[1] += gP.ilist[i].G * rBrightFactor1;
        Emit[2] += gP.ilist[i].B * rBrightFactor1;

        Grid[0] += gP.ilist[i].R * rBrightFactor2;
        Grid[1] += gP.ilist[i].G * rBrightFactor2;
        Grid[2] += gP.ilist[i].B * rBrightFactor2;
    }

    for(i = 0; i < gP.nEmitters - 1; i++) {
        k = max((i * 16) -1, 0);
        kBuffer = 200 + 2 + gP.SoundBuffer[k] * (50 + k / 255 * 140);
        glPushMatrix();
            x = gP.elist[i].X * gP.billboardMat[0] + gP.elist[i].Y * gP.billboardMat[4] + gP.elist[i].Z * gP.billboardMat[8];
            y = gP.elist[i].X * gP.billboardMat[1] + gP.elist[i].Y * gP.billboardMat[5] + gP.elist[i].Z * gP.billboardMat[9];
            z = gP.elist[i].X * gP.billboardMat[2] + gP.elist[i].Y * gP.billboardMat[6] + gP.elist[i].Z * gP.billboardMat[10];
            glTranslatef(x, y, z);
            p = 2 + (float) sqrt(Pulse);
            glScalef(p, p, p);
            glRotatef(UseAngle + (90 * i), 0, 0, 1);
            glColor4f(Emit[0], Emit[1], Emit[2], rAlpha);
            sSize = 100;
            DrawQuad(sSize, sSize, 0.0f, gP.mt[1].Texture);
        glPopMatrix();

        glPushMatrix();
            x = gP.alist[i].X * gP.billboardMat[0] + gP.alist[i].Y * gP.billboardMat[4] + gP.alist[i].Z * gP.billboardMat[8];
            y = gP.alist[i].X * gP.billboardMat[1] + gP.alist[i].Y * gP.billboardMat[5] + gP.alist[i].Z * gP.billboardMat[9];
            z = gP.alist[i].X * gP.billboardMat[2] + gP.alist[i].Y * gP.billboardMat[6] + gP.alist[i].Z * gP.billboardMat[10];
            glTranslatef(x, y, z);
            p = 1 * Pulse; glScalef(p, p, p);
            glRotatef(-UseAngle - (90.0f * i), 0, 0, 1);
            glColor4f(gsR[k] * gP.SoundBuffer[k], gsG[k] * gP.SoundBuffer[k], gsB[k] * gP.SoundBuffer[k] + 0.1f, rAlpha);
            sSize = kBuffer; // As K increases, the relative size of the signal
            DrawQuad(sSize, sSize, 0.0f, gP.mt[2].Texture);
        glPopMatrix();
    }

    i = gP.nEmitters - 1;
    k = max((i * 16) -1, 0);
    glPushMatrix();
        x = gP.alist[i].X * gP.billboardMat[0] + gP.alist[i].Y * gP.billboardMat[4] + gP.alist[i].Z * gP.billboardMat[8];
        y = gP.alist[i].X * gP.billboardMat[1] + gP.alist[i].Y * gP.billboardMat[5] + gP.alist[i].Z * gP.billboardMat[9];
        z = gP.alist[i].X * gP.billboardMat[2] + gP.alist[i].Y * gP.billboardMat[6] + gP.alist[i].Z * gP.billboardMat[10];
        glTranslatef(x, y, z);
        p = 1 * Pulse; glScalef(p, p, p);
        glRotatef(-UseAngle, 0, 0, 1);
//zTrace(STRL(k));
//zTrace(STRF(gsR[k]));
//zTrace(STRF(gsG[k]));
//zTrace(STRF(gsB[k]));
//zTrace(STRF(gP.SoundBuffer[k]));
        glColor4f(gsR[k] * gP.SoundBuffer[k], gsG[k] * gP.SoundBuffer[k], gsB[k] * gP.SoundBuffer[k] + 0.1f, rAlpha);
        sSize = kBuffer; // As K increases, the relative size of the signal
        DrawQuad(sSize, sSize, 0, gP.mt[2].Texture);
    glPopMatrix();

    glPushMatrix();
        glColor3f(Grid[0], Grid[1], Grid[2]);
        glTranslatef(0.0f, 0.0f, 0.0f);
        DrawQuad(1400, 700, 50.0f, gP.mt[3].Texture);
    glPopMatrix();
}


ExportC long BBProc (OUT BBPLUGIN &BBP) {
    long k = 0, i = 0, nRet = BBP_SUCCESS;
    float rAngle = 0, change = 0, changeRemaining = 0, sqrPulse = 0, cPulse = 0, Pulse = 0, rAspect = 0, cameraDistance;
    static long nNewTarget, nLastTarget, nInitDone, nIonsReleased;
    static float rWait, rInterp, rInterpconst, colorInterp, colorChange, blurfactor, diff;
    static float oldCameraDistance, targetCameraDistance, rReleaseTime;
    static double rPreinterp, preCameraInterp;
    static TrsRgb oldHsl, newHsl, targetHsl;
    static TrsVec radialVel, targetRadialVel;
    static TrsQuat rotQuat;
    TrsVec radialVelDiff = { 0 };
    TrsVec tempRadialVel = { 0 };
    TrsQuat radialQuat = { 0 };
    TrsMatrix rotMat = { 0 };

    switch (BBP.msg) {
    case BBP_RENDER:
        Pulse = (float) max(BBP.lpeak / 700.0f, BBP.lpeak / 700.0f) / 14.0f;
        cPulse = Pulse / 2.0f;

        MoveMemory(&gP.fft[0], BBP.fftdata, 256 * sizeof(float));
        // Try and smooth out the buffer by averaging the last results:
        //k = 0;
        //for (i = 0; i < 256; i+=8) { // < we use range 33 with the original version
        //    // We use SQR to bring out the midtone of the music, otherwise the spectrum is very flat.
        //    gP.SoundBuffer[k] = sqrtf(sqrtf(gP.fft[i]) * 2.0f);
        //    k++;
        //}

        for (i = 0; i < 32; i++) { // < we use range 33 with the original version
            // We use SQR to bring out the midtone of the music, otherwise the spectrum is very flat.
            gP.SoundBuffer[i] = (float)(sqrt(sqrt(gP.fft[i]) * 2.0f));
        }

        //short wd1, wd2;
        //for (i = 0; i < 32; i++) {
        //    // WIM MAGIC!
        //    // BBP.WIMdata returns a pointer to an area of memory
        //    // containing an array of 256 short integer.
        //    // Warning, the Left and Right audio channels are mixed together
        //    // thus we step 4, to consider only one channel.
        //    MoveMemory(&wd1, BBP.wimdata + i * 16, 2);
        //    MoveMemory(&wd2, BBP.wimdata + 2 + i * 16, 2);
        //    gP.SoundBuffer[i] = sqrtf(max((float)wd1 / 32767.0f, (float)wd2 / 32767.0f));
        //}

        //short wd1, wd2;
        //for (i = 0; i < 128; i++) {
        //    // WIM MAGIC!
        //    // BBP.WIMdata returns a pointer to an area of memory
        //    // containing an array of 256 short integer.
        //    // Warning, the Left and Right audio channels are mixed together
        //    // thus we step 4, to consider only one channel.
        //    MoveMemory(&wd1, BBP.wimdata + i * 4, 2);
        //    MoveMemory(&wd2, BBP.wimdata + 2 + i * 4, 2);
        //    gP.pv[i] = (float) max((float)wd1 / 32767.0f, (float)wd2 / 32767.0f);
        //}

        gP.rFrameTime = TrsTick();

        // We overwrite the global variable to smooth the camera movment based on the music pulse.
        gP.nSpeed = 10 + long(Pulse * 10.0f);

        // Camera movements
        // first do translation (distance from center)
        if (nInitDone == 0) {
            targetCameraDistance = -1000.0f;
            preCameraInterp = PI;
        }
        preCameraInterp += gP.nCameraSpeed * gP.rFrameTime * 0.01f;
        cameraDistance = -1300.0f;
        if (preCameraInterp >= PI) {
            oldCameraDistance = targetCameraDistance;
            targetCameraDistance = -rsRandf(1300.0f) - 200.0f;
            preCameraInterp = 0.0f;
        }
        glMatrixMode(GL_MODELVIEW);

        glLoadIdentity();

        glTranslatef(0.0f, 0.0f, cameraDistance);

        // Do rotation
        if (nInitDone == 0) {
            radialVel.X = 0.0f; 
            radialVel.Y = 0.0f; 
            radialVel.Z = 0.0f;
            targetRadialVel = radialVel;
            quat_set(rotQuat, 0.0f, 0.0f, 0.0f, 1.0f);
        }

        radialVelDiff.X = targetRadialVel.X - radialVel.X;
        radialVelDiff.Y = targetRadialVel.Y - radialVel.Y;
        radialVelDiff.Z = targetRadialVel.Z - radialVel.Z;
        changeRemaining = ion_normalize(radialVelDiff);
        change = gP.nCameraSpeed * 0.0002f * gP.rFrameTime;
        if (changeRemaining > change) {
            radialVelDiff.X *= change;
            radialVelDiff.Y *= change;
            radialVelDiff.Z *= change;
            radialVel.X += radialVelDiff.X;
            radialVel.Y += radialVelDiff.Y;
            radialVel.Z += radialVelDiff.Z;
        } else {
            radialVel = targetRadialVel;
            if (rsRandi(2)) {
                targetRadialVel.X = rsRandf(1.0f);
                targetRadialVel.Y = rsRandf(1.0f);
                targetRadialVel.Z = rsRandf(1.0f);
                ion_normalize(targetRadialVel);
                float rTmp = gP.nCameraSpeed * rsRandf(0.002f);
                targetRadialVel.X *= rTmp;
                targetRadialVel.Y *= rTmp;
                targetRadialVel.Z *= rTmp;
            } else {
                targetRadialVel.X = 0.0f;
                targetRadialVel.Y = 0.0f;
                targetRadialVel.Z = 0.0f;
            }
        }
        tempRadialVel = radialVel;
        rAngle = ion_normalize(tempRadialVel);
        quat_make(radialQuat, rAngle, tempRadialVel);
        quat_preMult(rotQuat, radialQuat);
        mat_fromQuat(rotMat, rotQuat);

        // Make billboard matrix for rotating particles when they are drawn
        MoveMemory(&gP.billboardMat[0], &rotMat, 64);

        // Calculate new color
        if (nInitDone == 0) {
            newHsl.R = 1.0f; newHsl.G = 1.0f; newHsl.B = 1.0f;
            colorInterp = 1.0f;
        }
        colorInterp += gP.rFrameTime * colorChange;
        if (colorInterp >= 1.0f) {
            if ((!rsRandi(3)) && (gP.nIons > 99)) {  // change color suddenly
                newHsl.R = rsRandf(1.0f);
                newHsl.G = 1.0f - (rsRandf(1.0f) * rsRandf(1.0f));
                newHsl.B = 1.0f;
            }
            oldHsl = newHsl;
            targetHsl.R = rsRandf(1.0f);
            targetHsl.G = 1.0f - (rsRandf(1.0f) * rsRandf(1.0f));
            targetHsl.B = 1.0f;
            colorInterp = 0.0f;
            // amount by which to change colorInterp each second
            colorChange = rsRandf(0.005f * gP.nSpeed) + (0.002f * gP.nSpeed);
        } else {
            diff = targetHsl.R - oldHsl.R;
            if ((diff < -0.5f) || ((diff > 0.0f) && (diff < 0.5f))) {
                newHsl.R = oldHsl.R + colorInterp * diff;
            } else {
                newHsl.R = oldHsl.R - colorInterp * diff;
            }
            diff = targetHsl.G - oldHsl.G;
            newHsl.G = oldHsl.G + colorInterp * diff;
            if (newHsl.R < 0.0f) { newHsl.R += 1.0f; }
            if (newHsl.R > 1.0f) { newHsl.R -= 1.0f; }
            hsl2rgb(newHsl.R, newHsl.G, 1.0f, gP.newRGB[0], gP.newRGB[1], gP.newRGB[2]);
        }

        // Release ions
        if (nIonsReleased < gP.nIons) {
            rReleaseTime -= gP.rFrameTime;
            while ((nIonsReleased < gP.nIons) && (rReleaseTime <= 0.0f)) {
                ion_start(nIonsReleased);
                nIonsReleased += 1;
                // all ions released after 2 minutes
                rReleaseTime += 120.0f / gP.nIons;
            }
        }

        // Set interpolation value for emitters and attracters
        if (rPreinterp == 0) { rPreinterp = PI; }
        if (rInterpconst == 0) { rInterpconst = 0.001f; }
        rWait -= gP.rFrameTime;
        if (rWait <= 0.0f) {
            rPreinterp += gP.rFrameTime * (gP.nSpeed) * rInterpconst;
            rInterp = 0.5f - (0.5f * (float)(cos(rPreinterp)));
        }
        if (rPreinterp >= PI) {
            // select new taget points (not the same pattern twice in a row)
            nLastTarget = nNewTarget;
            nNewTarget = rsRandi(10);
            if (nNewTarget == nLastTarget) {
                nNewTarget += 1;
            }

            setTargets(nNewTarget);

            rPreinterp = 0.0f;
            rInterp = 0.0f;
            rWait = 10.0f;  // pause after forming each new pattern
            rInterpconst = 0.001f;
            if (!rsRandi(4)) { // interpolate really fast sometimes
                rInterpconst = 0.1f;
            }
        }

        // Update particles
        for (i = 0; i < gP.nEmitters; i++) {
            emitter_interppos(i, rInterp);
        }
        for (i = 0; i < gP.nAttracters; i++) {
            attracter_interppos(i, rInterp);
        }
        for (i = 0; i < nIonsReleased; i++) {
            ion_update(i);
        }

        // Draw
        // clear the screen
        if (gP.rBlur != 0) {  // partially
            if (nInitDone == 0) { blurfactor = (float)(sqrt(sqrt(gP.rBlur)) * 0.15495f); }
            glMatrixMode(GL_PROJECTION);
            glPushMatrix();
                glLoadIdentity();
                glOrtho(0.0f, 1.0f, 0.0f, 1.0f, 1.0f, -1.0f);
                glMatrixMode(GL_MODELVIEW);
                glPushMatrix();
                    glLoadIdentity();
                    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
                    glColor4f(0.0f, 0.0f, 0.0f, 0.55f - blurfactor);
                    glBegin(GL_TRIANGLE_STRIP);
                        glVertex3f(0.0f, 0.0f, 0.0f);
                        glVertex3f(1.0f, 0.0f, 0.0f);
                        glVertex3f(0.0f, 1.0f, 0.0f);
                        glVertex3f(1.0f, 1.0f, 0.0f);
                    glEnd();
                glPopMatrix();
            glMatrixMode(GL_PROJECTION);
            glPopMatrix();
        } else {  // completely
            glClear(GL_COLOR_BUFFER_BIT);
        }

        nInitDone = -1;

        // Draw ions
        glMatrixMode(GL_MODELVIEW);
        glBlendFunc(GL_ONE, GL_ONE);
        glBindTexture(GL_TEXTURE_2D, gP.mt[0].Texture);

        sqrPulse = (float) sqrt(Pulse);
        for (i = 0; i < nIonsReleased; i++) {
            ion_draw(i, sqrPulse);
        }

        // Draw an object at the emitter / attracter center.
        glPushMatrix();
            quad_draw(Pulse);
        glPopMatrix();

        glFlush();

        // Very important we must reassign BBP.RC to the new BBP.DC
        // Note: don//t use permanent DC, this produce better and smoother display
        wglMakeCurrent(BBP.dc, BBP.rc);
        break;

    case BBP_CREATE:
        // Retrieve plugin details
        strcpy(BBP.title, "Helios");
        strcpy(BBP.author, "Patrice Terrier");
        BBP.version  = MAKEWORD(1, 0); // Version 1.0"
        BBP.renderto = BBP_OPENGL;     // or BBP_GDIPLUS, or BBP_DIRECTX
        break;

    case BBP_INIT:
        bbp_ColorInit();
        // Do your code initialisation there
        InitObject();
        glClearColor((GetRValue(BBP.backargb) + 1) / 256.0f, (GetGValue(BBP.backargb) + 1) / 256.0f, (GetBValue(BBP.backargb) + 1) / 256.0f, 1.0f);

        glDisable(GL_DEPTH_TEST);
        glEnable(GL_BLEND);
        glLightModeli(GL_LIGHT_MODEL_LOCAL_VIEWER, GL_TRUE);
        glEnable(GL_NORMALIZE);

        glEnable(GL_TEXTURE_2D);             // Enable Texture Mapping
        Path_Combine(gP.mt[0].FullName, TexturePath(), L"star2.jpg"); gP.mt[0].ID = 1; gP.mt[0].Square = 0; // Particle
        Path_Combine(gP.mt[1].FullName, TexturePath(), L"flare0.png"); gP.mt[1].ID = 2; gP.mt[1].Square = 0; // Emitter
        Path_Combine(gP.mt[2].FullName, TexturePath(), L"attracter.png"); gP.mt[2].ID = 3; gP.mt[2].Square = 0; // Attracter
        Path_Combine(gP.mt[3].FullName, TexturePath(), L"grid.png"); gP.mt[3].ID = 4; gP.mt[3].Square = 3; // Grid
        MakeMultipleTexture(&gP.mt[0], 4);

        // Initialize the particle display list
        glNewList(1, GL_COMPILE);
            glBindTexture(GL_TEXTURE_2D, gP.mt[0].Texture);
            glBegin(GL_TRIANGLES);
                glTexCoord2f(0.0f, 0.0f); glVertex3f(-0.5f, -0.5f, 0.0f);
                glTexCoord2f(1.0f, 0.0f); glVertex3f(0.5f, -0.5f, 0.0f);
                glTexCoord2f(1.0f, 1.0f); glVertex3f(0.5f, 0.5f, 0.0f);
                glTexCoord2f(0.0f, 0.0f); glVertex3f(-0.5f, -0.5f, 0.0f);
                glTexCoord2f(1.0f, 1.0f); glVertex3f(0.5f, 0.5f, 0.0f);
                glTexCoord2f(0.0f, 1.0f); glVertex3f(-0.5f, 0.5f, 0.0f);
            glEnd();
        glEndList();

        MakeColorLUT();
        break;

    case BBP_SIZE:
        // The size of the view port has changed.
        RECT rc; GetClientRect(BBP.parent, &rc);
        glViewport(0, 0, Width(rc), Height(rc));

        glMatrixMode(GL_PROJECTION);
        glLoadIdentity();
        rAspect = 0.0f;
        if (Height(rc)) { rAspect = (float) Width(rc) / (float) Height(rc); }
        gluPerspective(60.0f, rAspect, 0.1f, 10000.0f);

        //glMatrixMode(GL_MODELVIEW);
        break;

    case BBP_DESTROY:
        // Free up your resources there
        DestroyTexture (&gP.mt[0], 4);
        break;

    default:
        nRet = BBP_ERROR;
        break;
    }
    return nRet;
}

BOOL WINAPI DllMain (HINSTANCE hinstDLL, IN DWORD fdwReason, IN LPVOID lpvReserved) {
    switch (fdwReason) {
    case DLL_PROCESS_ATTACH:
        break;
    case DLL_PROCESS_DETACH:
        break;
    case DLL_THREAD_ATTACH:
        break;
    case DLL_THREAD_DETACH:
        break;
    }
    return TRUE;
}
