//+--------------------------------------------------------------------------+
//|                                                                          |
//|                                 Matrix                                   |
//|                          BassBox OpenGL plugin                           |
//|                                                                          |
//|                              Version 2.00                                |
//|                                                                          |
//+--------------------------------------------------------------------------+
//|                                                                          |
//|                         Author Patrice TERRIER                           |
//|                                                                          |
//|                         copyright(c) 2010-2017                           |
//|                                                                          |
//|                Patrice Terrier http://www.zapsolution.com                |
//|                                                                          |
//+--------------------------------------------------------------------------+
//|                  Project started on : 10-30-2009 (MM-DD-YYYY)            |
//|                        Last revised : 02-18-2017 (MM-DD-YYYY)            |
//+--------------------------------------------------------------------------+

//#include <windows.h>
//#include <mfapi.h>
//#include <gl/GL.h>
//#include <gl/GLU.h>
//#include <shlwapi.h>
//#include <math.h>
//#include <TimeAPI.h>
//#include <time.h>
//#include "gl2.h"
//#include <string.h>
//#include <stdio.h>

#include <windows.h>
//#include "..\TCLib\stdio.h"
//#include "..\TCLib\string.h"
//#include "..\TCLib\stdlib.h"
//#include "..\TCLib\memory.h"
//#include "..\TCLib\malloc.h"
#include "..\TCLib\math.h"
//#include "..\TCLib\tchar.h"
#include "..\TCLib\Strings.cpp"

#include <gl/GL.h>
#include <gl/GLU.h>
#include "gl2.h"

typedef ULONGLONG QWORD;
#include "BBplugin.h"
#define ExportC extern "C" _declspec (dllexport)

#define PI         3.14159265359
#define PIx2       6.28318530718
#define RS_EPSILON 0.000001

struct MatrixLetters {
    BYTE letter;   // ID
    float active;  // Active count
    float fade;    // Color fade
    float a;       // Alpha value
    float r;       // Red value
    float g;       // Green value
    float b;       // Blue value
    float x;       // X Position
    float y;       // Y Position
    float z;       // Z Position
};

struct PROP {
    GLuint charlist;
    GLuint firelist;
    float fzoom;
    long nLevel;
    long bailout;
    long loaded;
    BYTE bRed;
    BYTE bGreen;
    BYTE bBlue;
    BYTE bAlpha;
    BBPTEXTURE mt[4];
};

PROP gP;

DWORD g_color[33];              
float gsR[33], gsG[33], gsB[33];
float gfR[32], gfG[32], gfB[32];
BYTE gnR[33], gnG[33], gnB[33];
MatrixLetters g_ml[6642];

void ColorInit() {
    float sCoef = 0.75f;
    g_color[0]  = RGB(32  * sCoef,  32 * sCoef,  32 * sCoef);
    g_color[1]  = RGB(0   * sCoef,  20 * sCoef, 253 * sCoef);
    g_color[2]  = RGB(0   * sCoef,  44 * sCoef, 233 * sCoef);
    g_color[3]  = RGB(0   * sCoef,  67 * sCoef, 210 * sCoef);
    g_color[4]  = RGB(0   * sCoef,  89 * sCoef, 187 * sCoef);
    g_color[5]  = RGB(0   * sCoef, 112 * sCoef, 164 * sCoef);
    g_color[6]  = RGB(0   * sCoef, 135 * sCoef, 142 * sCoef);
    g_color[7]  = RGB(0   * sCoef, 159 * sCoef, 117 * sCoef);
    g_color[8]  = RGB(0   * sCoef, 183 * sCoef,  88 * sCoef);
    g_color[9]  = RGB(0   * sCoef, 207 * sCoef,  58 * sCoef);
    g_color[10] = RGB(0   * sCoef, 231 * sCoef,  29 * sCoef);
    g_color[11] = RGB(26  * sCoef, 234 * sCoef,  26 * sCoef);
    g_color[12] = RGB(52  * sCoef, 237 * sCoef,  23 * sCoef);
    g_color[13] = RGB(79  * sCoef, 240 * sCoef,  20 * sCoef);
    g_color[14] = RGB(105 * sCoef, 243 * sCoef,  17 * sCoef);
    g_color[15] = RGB(126 * sCoef, 245 * sCoef,  14 * sCoef);
    g_color[16] = RGB(147 * sCoef, 248 * sCoef,  11 * sCoef);
    g_color[17] = RGB(168 * sCoef, 250 * sCoef,   8 * sCoef);
    g_color[18] = RGB(189 * sCoef, 253 * sCoef,   5 * sCoef);
    g_color[19] = RGB(210 * sCoef, 255 * sCoef,   2 * sCoef);
    g_color[20] = RGB(233 * sCoef, 255 * sCoef,   0 * sCoef);
    g_color[21] = RGB(255 * sCoef, 255 * sCoef,   0 * sCoef);
    g_color[22] = RGB(255 * sCoef, 251 * sCoef,   0 * sCoef);
    g_color[23] = RGB(255 * sCoef, 235 * sCoef,   0 * sCoef);
    g_color[24] = RGB(255 * sCoef, 215 * sCoef,   0 * sCoef);
    g_color[25] = RGB(255 * sCoef, 196 * sCoef,   0 * sCoef);
    g_color[26] = RGB(255 * sCoef, 176 * sCoef,   0 * sCoef);
    g_color[27] = RGB(255 * sCoef, 156 * sCoef,   0 * sCoef);
    g_color[28] = RGB(253 * sCoef, 137 * sCoef,   0 * sCoef);
    g_color[39] = RGB(255 * sCoef, 117 * sCoef,   0 * sCoef);
    g_color[30] = RGB(255 * sCoef,  97 * sCoef,   0 * sCoef);
    g_color[31] = RGB(255 * sCoef,  78 * sCoef,   0 * sCoef);
    g_color[32] = RGB(255 * sCoef,  58 * sCoef,   0 * sCoef);
}

void MakeColorLUT() {
    COLORBYTES bytestruct;
    for (long K = 0; K < 33; K++) {
        MoveMemory(&bytestruct, &g_color[K], sizeof(COLORBYTES));
        gnR[K] = bytestruct.R;
        gnG[K] = bytestruct.G;
        gnB[K] = bytestruct.B;
    }
}

void MakeColorFLUT() {
    COLORBYTES bytestruct;
    for (long K = 0; K < 32; K++) {
        MoveMemory(&bytestruct, &g_color[K + 1], sizeof(COLORBYTES));
        gfR[K] = (float)(bytestruct.R / 255.0f);
        gfG[K] = (float)(bytestruct.G / 255.0f);
        gfB[K] = (float)(bytestruct.B / 255.0f);
    }
}

void ColorInitFloat() {
    gsR[ 0] = 175/255.0f; gsG[ 0] = 9/255.0f;   gsB[ 0] = 155/255.0f;
    gsR[ 1] = 0.0f;       gsG[ 1] = 32/255.0f;  gsB[ 1] = 252/255.0f;
    gsR[ 2] = 0.0f;       gsG[ 2] = 44/255.0f;  gsB[ 2] = 223/255.0f;
    gsR[ 3] = 0.0f;       gsG[ 3] = 67/255.0f;  gsB[ 3] = 210/255.0f;
    gsR[ 4] = 0.0f;       gsG[ 4] = 89/255.0f;  gsB[ 4] = 187/255.0f;
    gsR[ 5] = 0.0f;       gsG[ 5] = 112/255.0f; gsB[ 5] = 164/255.0f;
    gsR[ 6] = 0.0f;       gsG[ 6] = 135/255.0f; gsB[ 6] = 142/255.0f;
    gsR[ 7] = 0.0f;       gsG[ 7] = 159/255.0f; gsB[ 7] = 117/255.0f;
    gsR[ 8] = 0.0f;       gsG[ 8] = 183/255.0f; gsB[ 8] = 88/255.0f;
    gsR[ 9] = 0.0f;       gsG[ 9] = 207/255.0f; gsB[ 9] = 58/255.0f;
    gsR[10] = 0.0f;       gsG[10] = 231/255.0f; gsB[10] = 29/255.0f;
    gsR[11] = 26/255.0f;  gsG[11] = 234/255.0f; gsB[11] = 26/255.0f;
    gsR[12] = 52/255.0f;  gsG[12] = 237/255.0f; gsB[12] = 23/255.0f;
    gsR[13] = 79/255.0f;  gsG[13] = 240/255.0f; gsB[13] = 20/255.0f;
    gsR[14] = 105/255.0f; gsG[14] = 243/255.0f; gsB[14] = 17/255.0f;
    gsR[15] = 126/255.0f; gsG[15] = 245/255.0f; gsB[15] = 14/255.0f;
    gsR[16] = 147/255.0f; gsG[16] = 248/255.0f; gsB[16] = 11/255.0f;
    gsR[17] = 168/255.0f; gsG[17] = 250/255.0f; gsB[17] = 8/255.0f;
    gsR[18] = 189/255.0f; gsG[18] = 253/255.0f; gsB[18] = 5/255.0f;
    gsR[19] = 210/255.0f; gsG[19] = 1.0f;       gsB[19] = 3/255.0f;
    gsR[20] = 223/255.0f; gsG[20] = 1.0f;       gsB[20] = 0.0f;
    gsR[21] = 235/255.0f; gsG[21] = 1.0f;       gsB[21] = 0.0f;
    gsR[22] = 245/255.0f; gsG[22] = 251/255.0f; gsB[22] = 0.0f;
    gsR[23] = 1.0f;       gsG[23] = 235/255.0f; gsB[23] = 0.0f;
    gsR[24] = 1.0f;       gsG[24] = 215/255.0f; gsB[24] = 0.0f;
    gsR[25] = 1.0f;       gsG[25] = 196/255.0f; gsB[25] = 0.0f;
    gsR[26] = 1.0f;       gsG[26] = 176/255.0f; gsB[26] = 0.0f;
    gsR[27] = 1.0f;       gsG[27] = 156/255.0f; gsB[27] = 0.0f;
    gsR[28] = 1.0f;       gsG[28] = 137/255.0f; gsB[28] = 0.0f;
    gsR[29] = 1.0f;       gsG[29] = 117/255.0f; gsB[29] = 0.0f;
    gsR[30] = 1.0f;       gsG[30] = 97/255.0f;  gsB[30] = 0.0f;
    gsR[31] = 1.0f;       gsG[31] = 78/255.0f;  gsB[31] = 0.0f;
    gsR[32] = 1.0f;       gsG[32] = 58/255.0f;  gsB[32] = 0.0f;
}

BYTE UpDown (IN BYTE alpha) {
    static long PauseAll, PauseMin, PauseMax, nReverse;
    static BYTE MaxVal, MinVal;

    if (MinVal != 105) { MinVal = 105; }
    if (MaxVal != 250) { MaxVal = 250; }
    if (PauseAll <= 0) { PauseAll = 2; } 
    if (alpha < MinVal) { alpha = MinVal; }
    PauseAll -= 1;
    if (PauseAll <= 0) {
        switch(nReverse) {
        case 0:
            if (alpha < MaxVal) { alpha += 1; }
            if (PauseMax > 0) { PauseMax -= 1; }
            if (PauseMax <= 0) {
                PauseMax = 10;
                if (alpha >= MaxVal || alpha >= MaxVal) { nReverse = 1; }
            }
            break;
        case 1:
            if (alpha > 0) { alpha -= 1; }
            if (PauseMin > 0) { PauseMin -= 1; }
            if (PauseMin <= 0) {
                PauseMin = 1;
                if (alpha <= 0 || alpha <= MinVal) { nReverse = 0; }
            }
            break;
        }
    }
    return alpha;
}

void DrawBackground(IN float pulse) {
    float sPulse = 2 * pulse;
    glBegin(GL_QUADS);
       glTexCoord2f(0.0f, 0.0f); glVertex3f(-100.0f,-50.0f,-120.0f + sPulse); // Bottom Left Of The Texture And Quad
       glTexCoord2f(1.0f, 0.0f); glVertex3f( 100.0f,-50.0f,-120.0f + sPulse); // Bottom Right Of The Texture And Quad
       glTexCoord2f(1.0f, 1.0f); glVertex3f( 100.0f, 50.0f,-120.0f + sPulse); // Top Right Of The Texture And Quad
       glTexCoord2f(0.0f, 1.0f); glVertex3f(-100.0f, 50.0f,-120.0f + sPulse); // Top Left Of The Texture And Quad
    glEnd();
}

void RGBASquare (IN float ecke, IN float v1, IN float v2, IN float v3, IN BYTE bRed, IN BYTE bGreen, IN BYTE bBlue, IN BYTE bAlpha) {
    ecke /= 2.0f;
    glBegin(GL_QUADS);
        glNormal3f(0.0f, 0.0f, 1.0f);
        glColor4ub(bBlue, bRed, bGreen, bAlpha);
        glTexCoord2f(1.0f, 0.0f); glVertex3f(ecke + v1, ecke - v2, ecke - v3); // Bottom Right
        glColor4ub(bGreen, bBlue, bRed, bAlpha);
        glTexCoord2f(1.0f, 1.0f); glVertex3f(ecke + v1, ecke + v2, ecke - v3); // Top Right
        glColor4ub(bRed, bGreen, bBlue, bAlpha);
        glTexCoord2f(0.0f, 1.0f); glVertex3f(ecke - v1, ecke + v2, ecke - v3); // Top Left
        glColor4ub(bGreen, bRed, bBlue, bAlpha);
        glTexCoord2f(0.0f, 0.0f); glVertex3f(ecke - v1, ecke - v2, ecke - v3); // Bottom Left
    glEnd();
}

long GetHighLevel (IN long MaxLevel, IN long rw) {
    static long HighLevel, tcount;
    if (rw) {
        if (MaxLevel == 0) { tcount += 400; }
        if (MaxLevel < HighLevel - 1) { tcount += 1; }
        if (MaxLevel > HighLevel) {
            HighLevel += 2;
            if (MaxLevel) { tcount = 0; }
        }
        if (tcount > 1999) { HighLevel -= 1; tcount = 0; }
    }
    return HighLevel;
}

long XY(IN long x, IN long y) {
    return 80 * x + y;
}

void DrawListNumber(IN GLuint ListBase, IN long xn) {
    BYTE letter[1];
    if (xn > 255) { xn = 126; }
    if (xn < 0) {
       if (gP.nLevel > 0) {
          xn = rsRandi(55);
       } else {
          xn /= -2;
       }
    }
    letter[0] = (BYTE) xn;

    GLboolean DEPTH_TEST_ON = glIsEnabled(GL_DEPTH_TEST); if (DEPTH_TEST_ON) { glDisable(GL_DEPTH_TEST); }
    GLboolean LIGHT_ON = glIsEnabled(GL_LIGHTING); if (LIGHT_ON) { glDisable(GL_LIGHTING); }
    glPushAttrib(GL_LIST_BIT);
        glListBase(ListBase);
        glCallLists(1, GL_UNSIGNED_BYTE, &letter[0]);
    glPopAttrib();
    if (DEPTH_TEST_ON) { glEnable(GL_DEPTH_TEST); }
    if (LIGHT_ON) { glEnable(GL_LIGHTING); }
}

void FontItemRotationX(IN GLuint ListBase, IN long xn, IN float camera, IN float sXPos, IN float sYPos, IN float sZPos) {
    glLoadIdentity();
    glTranslatef(sXPos, sYPos, sZPos);
    glRotatef(camera, 1.0f, 0.0f, 0.0f);
    DrawListNumber(ListBase, xn);
}

void MatrixPoint_Color4f(IN long sXYPos) {
    sXYPos = min(max(sXYPos, 0), 80 * 81);
    float alpha = 0.0f; if ((GetHighLevel(0,0) > 0) && (gP.nLevel > 0)) { alpha = 1.0f / (30.0f * (gP.nLevel / GetHighLevel(0,0))); }
    glColor4f(g_ml[sXYPos].r / 3.6f, g_ml[sXYPos].g / 1.5f, g_ml[sXYPos].b / 2.8f, g_ml[sXYPos].a - alpha );
}

float Color3D_Matrix(IN GLuint ListBase, IN float camera, IN float stzoom, IN float ztime) {

    static float LocA, LocB, inzoomB, xplusA, Bon, xplusB, XWall;
    static long isWall, yplusA, yplusB;
    long xy, FrameX, FrameY;
    float inzoomA;

    //RandomizeTimer();

    LocA += 0.5f;
    inzoomA = stzoom + ztime;
    if (yplusA < 79) { yplusA += 1; }
    glLoadIdentity();
    for (FrameY = yplusA; FrameY > -1; FrameY--) {
        //if (yplusA == 1) { xplusA = 15.0f + max(5, rsRandf(20)); XWall = -25.0f + max(1, rsRandf(50)); }
        if (yplusA == 1) { xplusA = 15.0f + rnd(5, 20); XWall = -25.0f + rnd(1, 50); }
        for (FrameX = 1; FrameX < 80; FrameX +=2) {
            xy = XY(FrameX,FrameY);
            MatrixPoint_Color4f(xy);
            switch (FrameX) {
            case 1:
                FontItemRotationX(ListBase, g_ml[xy].letter, camera * (gP.bAlpha / 20.0f), 20.0f + FrameX - xplusA, 60.0f + FrameY - yplusA - (yplusA / 8) - (LocA / 12), (inzoomA / 6) + (yplusA / 4) - ( 79 / 6));
                break;
            case 3:
                FontItemRotationX(ListBase, g_ml[xy].letter, 0.0f, 15.0f + FrameX - xplusA, 65.0f + FrameY - yplusA - (yplusA / 8) - (LocA / 12), (inzoomA / 6) + (yplusA / 6) - (79 / 6));
                break;
            case 5:
                FontItemRotationX(ListBase, g_ml[xy].letter, 0.0f, 35.0f + FrameX - xplusA, 65.0f + FrameY - yplusA -( yplusA / 8) -( LocA / 12), (inzoomA / 6) + (yplusA / 6) - (79 / 6));
                break;
            case 7:
                FontItemRotationX(ListBase, g_ml[xy].letter, camera * (gP.bAlpha / 20.0f), 25.0f + FrameX - xplusA, 70.0f + FrameY-yplusA-(yplusA / 8) - (LocA / 12), (inzoomA / 4 )+(yplusA / 4)-(79 / 4));
                break;
            case 9:
                FontItemRotationX(ListBase, g_ml[xy].letter, 0.0f, 30.0f + FrameX + (xplusA * 2), 100.0f + FrameY - yplusA - (yplusA / 8)-(LocA / 7), inzoomA + yplusA - 79);
                break;
            case 11:
                FontItemRotationX(ListBase, g_ml[xy].letter, camera * (gP.bAlpha / 20.0f), 45.0f + FrameX + xplusA, 75.0f + FrameY - yplusA - (yplusA / 8)-(LocA / 12), (inzoomA / 6) + (yplusA / 6)-(79 / 6));
                break;
            case 15:
                FontItemRotationX(ListBase, g_ml[xy].letter, 0.0f, -25.0f + (xplusA * 2) + FrameX, 135.0f + FrameY - yplusA - (yplusA / 8) - (LocA / 7), (inzoomA / 2)+(yplusA / 2) - (79 / 2));
                break;
            case 17:
                if ((isWall < 4) || (isWall > 5)) { 
                    FontItemRotationX(ListBase, g_ml[xy].letter, 0.0f, 5.0f + FrameX - (xplusA * 2), 85.0f + FrameY-yplusA-(yplusA / 8)  -(LocA / 12), (inzoomA / 5) + (yplusA / 5) - (79 / 5) + (LocA / 5000));
                }
                break;
            case 19:
                FontItemRotationX(ListBase, g_ml[xy].letter, 0.0f,-2.0f + FrameX-(xplusA * 2), 55.0f + FrameY - yplusA - (yplusA / 8) - (LocA / 12), (inzoomA / 8) + (yplusA / 8) - (79 / 4));
                break;
            case 21:
                if (inzoomA <  -300) {
                    FontItemRotationX(ListBase, g_ml[xy].letter, 0.0f, -5.0f + xplusA + FrameX, 135.0f + (FrameY - yplusA) - (yplusA / 8) - (LocA / 7 ), inzoomA + yplusA - 79);
                }
                if (inzoomA >= -300) { 
                    FontItemRotationX(ListBase, g_ml[xy].letter, camera * (gP.bAlpha / 100.0f), -5.0f + xplusA + FrameX, 135.0f + (FrameY - yplusA) - (yplusA / 8)-(LocA / 7), inzoomA + yplusA - 79);
                }
                break;
            case 23:
                FontItemRotationX(ListBase, g_ml[xy].letter, camera * (gP.bAlpha / 30.0f), 20.0f + FrameX - xplusA, 85.0f + FrameY - yplusA - (yplusA / 8)-(LocA / 12), (inzoomA / 4) + (yplusA / 4) - (79 / 4));
                break;
            case 25:
                if (yplusA < 79) { 
                    FontItemRotationX(ListBase, g_ml[xy].letter, 0.0f, -17.0f + FrameX - (xplusA * 2), 59.0f + FrameY - yplusA - (yplusA / 8) - (LocA / 12), (inzoomA / 6) + (yplusA / 6) - (79 / 6));
                }
                if (yplusA >= 79) {
                    FontItemRotationX(ListBase, g_ml[xy].letter, 0.0f, -17.0f + FrameX - (xplusA * 2), 59.0f + FrameY - yplusA - (yplusA / 8) - (LocA / 12), (inzoomA / 6) + (yplusA / 6) - (79 / 6) + (LocA / 1000));
                }
                break;
            case 27:
                FontItemRotationX(ListBase, g_ml[xy].letter, 0.0f, -5.0f + (xplusA / 2) + FrameX, 115.0f + (FrameY - yplusA) - (yplusA / 8) - (LocA / 7), inzoomA + yplusA + 21);
                break;
            case 31:
                FontItemRotationX(ListBase, g_ml[xy].letter, 0.0f, -60.0f + FrameX - (xplusA * 2), 125.0f + FrameY - yplusA - (yplusA / 8) - (LocA / 7), inzoomA + yplusA - 79);
            case 35:
                FontItemRotationX(ListBase, g_ml[xy].letter, 0.0f, FrameX + xplusA, 105.0f + (FrameY - yplusA) - (yplusA / 8) - (LocA / 12), inzoomA + yplusA - 79);
                break;
            case 41:
                if (isWall < 4 || isWall > 5) {
                    FontItemRotationX(ListBase, g_ml[xy].letter, camera * (gP.bAlpha / 30.0f), 5.0f + FrameX - (xplusA / 2), 61.0f + FrameY - yplusA - (yplusA / 8) - (LocA / 12), (inzoomA / 5) + (yplusA / 5) - (79 / 5));
                }
                break;
            case 75: 
                if (yplusA < 79) {
                    FontItemRotationX(ListBase, g_ml[xy].letter, 0.0f, 5.0f + FrameX + (xplusA * 2), 75.0f + FrameY - yplusA - (yplusA / 8) - (LocA / 12), (inzoomA / 8) + (yplusA / 8) - (79 / 8));
                }
                if (yplusA > 78) {
                    FontItemRotationX(ListBase, g_ml[xy].letter, 0.0f, 5.0f + FrameX - (xplusA * 2), 75.0f + FrameY - yplusA -( yplusA / 8) - (LocA / 12), (inzoomA / 8) + (yplusA / 8) - (79 / 8) + (LocA / 1000));
                }
                break;
            case 79:
                if (isWall < 4 || isWall > 5) {
                    FontItemRotationX(ListBase, g_ml[xy].letter, camera * (gP.bAlpha / 30.0f), -20.0f + FrameX - xplusA, 85.0f + FrameY - yplusA - (yplusA / 8) - (LocA / 12), (inzoomA / 4) + (yplusA / 4) - (79 / 4));
                }
                break;
            default:
                if ((isWall == 4) && (FrameX > 35)) {
                    glPushMatrix();
                        if (inzoomA < -500) {
                            FontItemRotationX(ListBase, g_ml[xy].letter, camera * 0.0f, -30.0f + FrameX - XWall, 115.0f + (FrameY - yplusA) - (yplusA / 8) - (LocA / 7), inzoomA + 410 - (yplusA * 2));
                        }
                        if (inzoomA >= -500) {
                            FontItemRotationX(ListBase, g_ml[xy].letter, camera * (gP.bAlpha / 110.0f), -30.0f + FrameX - XWall, 115.0f + (FrameY - yplusA) - ( yplusA / 8) - (LocA / 7), (inzoomA / 2) + 160 - (yplusA * 2));
                        }
                    glPopMatrix();
                }
                break;
            }
        }
    }
    if (!gP.bailout) {
        if ((inzoomA > stzoom / 2.0f) || (LocB >= 0.5f)) {
            LocB += 0.5;
            if ((inzoomA < -1) && (Bon == 0)) {
                inzoomB = (stzoom / 2) + inzoomA;
            } else if ((inzoomB < -1) && (Bon == 1)) {
                inzoomB += 1;
            }
            if (yplusB < 79) { yplusB += 1; }
           
            for (FrameY = yplusB; FrameY > -1; FrameY--) {
                if (gP.bailout) { break; }
                if (yplusB == 1) { xplusB = rsRandf(20); }
                for (FrameX = 4; FrameX < 79; FrameX +=2) {
                    xy = XY(FrameX,FrameY);
                    MatrixPoint_Color4f(xy);
                    glPushMatrix();
                       switch(FrameX) {
                       case 4:
                           FontItemRotationX(ListBase, g_ml[xy].letter, camera*(gP.bAlpha / 30.0f), -8.0f + FrameX + xplusB, 85.0f + FrameY - yplusB - (yplusB / 8.0f)-(LocB / 12.0f), (inzoomB / 6.0f) + (yplusB / 6.0f) - (79.0f / 6.0f));
                           break;
                       case 6:
                           FontItemRotationX(ListBase, g_ml[xy].letter, camera*(gP.bAlpha / 20.0f), -10.0f + FrameX + xplusB, 115.0f + FrameY - yplusB - (yplusB / 8.0f) - (LocB / 12.0f), (inzoomB / 4.0f) + (yplusB / 4.0f) - (79.0f / 4.0f));
                           break;
                       case 8:
                           if (isWall < 4 || isWall > 5) {
                               FontItemRotationX(ListBase, g_ml[xy].letter, camera * 0.0f, 2.0f + FrameX + (xplusB * 2.0f), 135.0f + FrameY - yplusB - (yplusB / 8.0f)-(LocB / 7.0f), inzoomB + yplusB - (79.0f / 4.0f));
                           }
                           break;
                       case 10:
                           FontItemRotationX(ListBase, g_ml[xy].letter, camera * 0.0f, 20.0f + FrameX+(xplusB * 2.0f), 130.0f + FrameY - yplusB - (yplusB / 8.0f) - (LocB / 7.0f), inzoomB+yplusB-79);
                           break;
                       case 12:
                           FontItemRotationX(ListBase, g_ml[xy].letter, camera * 0.0f, -10.0f +(xplusB * 2.0f) + FrameX, 135.0f + FrameY - yplusB - (yplusB / 8.0f) - (LocB / 7.0f), (inzoomB / 2.0f) + (yplusB / 2.0f) - (79.0f / 2.0f));
                           break;
                       case 14:
                           if (inzoomB <  -300) {
                               FontItemRotationX(ListBase, g_ml[xy].letter, camera * 0.0f, -5.0f + (xplusB) + FrameX, 135.0f + (FrameY-yplusB)-(yplusB/8)-(LocB/7), inzoomB + yplusB - 79.0f);
                           }
                           if (inzoomB >= -300) {
                               FontItemRotationX(ListBase, g_ml[xy].letter, camera * (gP.bAlpha / 100), -5.0f + (xplusB) + FrameX, 135.0f + (FrameY-yplusB)-(yplusB/8)-(LocB/7), inzoomB + yplusB- 79.0f);
                           }
                           break;
                       case 20:
                           if (isWall != 4) {
                               FontItemRotationX(ListBase, g_ml[xy].letter, camera * 0.0f, -10.0f + FrameX - xplusB, 115.0f + FrameY - yplusB - (yplusB / 8.0f) - (LocB / 7.0f), inzoomB + yplusB - 79.0f);
                           }
                           break;
                       case 26:
                           FontItemRotationX(ListBase, g_ml[xy].letter, camera * 0.0f, -15.0f + (xplusB) + FrameX, 138.0f + (FrameY - yplusB) - (yplusB / 8.0f)-(LocB / 7.0f), inzoomB + yplusB - 79.0f);
                           break;
                       case 74:
                           if (yplusB < 78) {
                               FontItemRotationX(ListBase, g_ml[xy].letter, camera * 0.0f, -25.0f + FrameX - (xplusB * 2.0f), 95.0f + FrameY - yplusB - (yplusB / 8.0f) -( LocB / 12.0f), (inzoomB / 8.0f) + (yplusB / 8.0f) - (79.0f / 8.0f));
                           }
                           if (yplusB > 77) {
                               FontItemRotationX(ListBase, g_ml[xy].letter, camera * 0.0f, -25.0f + FrameX - (xplusB * 2.0f), 95.0f + FrameY - yplusB - (yplusB / 8.0f) - (LocB / 12.0f), (inzoomB / 8.0f) + (yplusB / 8.0f) - (79.0f / 8.0f) + (LocB / 1000.0f));
                           }
                           break;
                       case 78:
                           FontItemRotationX(ListBase, g_ml[xy].letter, camera * 0.0f, 20.0f +(xplusB * 2.0f) + FrameX, 95.0f + FrameY - yplusB - (yplusB / 8.0f) - (LocB / 7.0f), (inzoomB / 2.0f) + (yplusB / 2.0f) - (79.0f / 2.0f));
                           break;
                       }
                    glPopMatrix();
                }
            }
        }
        if (inzoomA >= -1) {
            Bon = 1;
            LocA = 0.0f;
            if (yplusA > 78) { yplusA = 0; }
            gP.loaded = -1;
            if (isWall = 10) {
                isWall = 1;
            } else {
                isWall += 1;
            }
        }
        if (inzoomB >= -1) {
            Bon = 0;
            LocB = 0.5f;
            if (yplusB > 78) { yplusB = 0; }
        }
    }
    return LocA;
}

void Set3D_Matrix(IN GLuint ListBase, IN float camera, IN long nSignal, IN float stzoom, IN float ztime) {
    static long I, nSi, nShl;
    static float K, atLocA;
    static float mf[80][3];
    long FrameX = 0, FrameY = 0, xy, xy1;

    static BYTE useletter;

    if (!gP.bailout) {
        //RandomizeTimer();
        nSi = GetHighLevel(nSignal, -1);
        if (nSi < 1 || nSignal > 32) {
            if (mf[FrameX][0] > 78 && K == 4) { mf[FrameX][0] = 1; }
            mf[FrameX][0] = mf[FrameX][0] + (nSignal / 33);
        }
        if (nSignal > 31) { nSignal -= 3; }
        for (FrameX = 0; FrameX < 80; FrameX++) {
            I = 0;
            if (gP.loaded == 0) {
                nSignal = 4;
                mf[FrameX][2] = mf[FrameX][2] + 1;
                if (mf[FrameX][2] == 80) { mf[FrameX][2] = 0; nSignal = 3; }
            }
            if (atLocA == 0) {
                mf[FrameX][1] = mf[FrameX][1] + (nSignal / 198.0f);
            } else {
                mf[FrameX][1] = mf[FrameX][1] + (nSignal / 99.0f);
            }
            if (mf[FrameX][1] > mf[FrameX][0]) {
                mf[FrameX][1] = 0;
                I = 1;
            }
            if (nSi <= 1 && atLocA == 0) { nSignal = 2; mf[FrameX][1] = 0; I = 1; }
            for (FrameY = 0; FrameY < 80; FrameY++) {
                xy = XY(FrameX, FrameY);
                if (I) {
                    xy1 = XY(FrameX, FrameY + 1);
                    g_ml[xy].letter = g_ml[xy1].letter;
                    g_ml[xy].fade = g_ml[xy1].fade;
                    g_ml[xy].r = g_ml[xy1].r;
                    g_ml[xy].g = g_ml[xy1].g;
                    g_ml[xy].b = g_ml[xy1].b;
                    g_ml[xy].a = g_ml[xy1].a;
                }
                if (nSignal > 2) {
                    g_ml[xy].r = g_ml[xy].r + (g_ml[xy].fade * 0.010f);
                    g_ml[xy].g = g_ml[xy].g + (g_ml[xy].fade * 0.020f);
                    g_ml[xy].b = g_ml[xy].b + (g_ml[xy].fade * 0.010f);
                    g_ml[xy].a = g_ml[xy].a + (g_ml[xy].fade * 0.025f);
                }
                if (gP.loaded) {
                    nShl = GetHighLevel(nSignal,-1);
                    if (nSignal > nShl - 5) {
                        if ((g_ml[xy].g > 0.94f) || (g_ml[xy].g < 0.09f) || (g_ml[xy].a > 0.98f)) {
                            g_ml[xy].fade = -g_ml[xy].fade;
                        }
                    }
                } else {
                    if (g_ml[xy].b > 0.78f || g_ml[xy].g < 0.38f || g_ml[xy].a < 0.38f || g_ml[xy].a > 0.78f || g_ml[xy].r > 0.77f) {
                        g_ml[xy].fade = -g_ml[xy].fade;
                    }
                }
            }
            if (K == 4.0f) { K = 0.0f; }
            if (nSignal > nSi - 4) {
                mf[FrameX][2] = mf[FrameX][2] + (nSignal * 33.33f);
                if (mf[FrameX][2] > 79) {
                    mf[FrameX][2] = 0;
                    g_ml[XY(FrameX,80)].letter = 0;
                    mf[FrameX][0] = 0.5f + (nSignal / 62.0f);
                }
            } else {
                K += 1.0f;
                if (nSignal > 1 || gP.loaded == 0) {
                    if (useletter == 255) { useletter = 0; }
                    useletter++;
                    //useletter = (BYTE) max(1, rsRandi(255));
//zTrace(STRL(useletter));
                    g_ml[XY(FrameX,80)].letter = useletter;
                    //g_ml[XY(FrameX,80)].fade = max(2.0f, rsRandf(5)) - 2.0f;
                    g_ml[XY(FrameX,80)].fade = rnd(2, 5) - 2.0f;
                    //g_ml[XY(FrameX,80)].r = ((1.0f / nSignal) * 0.1f) + ((max(2, rsRandf(nSi * 0.5f)))) * 0.001f;
                    g_ml[XY(FrameX,80)].r = ((1.0f / nSignal) * 0.1f) + rnd(2, nSi / 2) * 0.001f;
                    //g_ml[XY(FrameX,80)].g = (1.0f / nSignal + (max(3.0f, rsRandf(nSi * 2.0f)))) * 0.01f;
                    g_ml[XY(FrameX,80)].g = (1.0f / nSignal + rnd(3, nSi * 2)) * 0.01f;
                    //g_ml[XY(FrameX,80)].b = ((1.0f / nSignal) * 0.01f) + (max(2, rsRandf(nSi * 0.33f))) / (nSignal * 10.0f);
                    g_ml[XY(FrameX,80)].b = ((1.0f / nSignal) * 0.01f) + rnd(2, nSi / 3) / (nSignal * 10.0f);

                    g_ml[XY(FrameX,80)].a = (float(random()) / 327.67f) * 0.001f + 0.003f;
                    //g_ml[XY(FrameX,80)].a = (rand() * 100) * 0.001f + 0.003f;
                }
            }
        }
        if (!gP.bailout) { atLocA = Color3D_Matrix(ListBase, camera, stzoom, ztime); }
    }
}

void DrawTextNumber(IN GLuint ListBase, IN BYTE xn) {
    BYTE letter[1];
    letter[0] = xn;
    GLboolean ALPHA_TEST_ON = glIsEnabled(GL_ALPHA_TEST); if (ALPHA_TEST_ON) { glDisable(GL_ALPHA_TEST); }
    GLboolean LIGHT_ON = glIsEnabled(GL_LIGHTING); if (LIGHT_ON) { glDisable(GL_LIGHTING); }
    glScalef(1.0f, 1.0f, 1.0f);
    glPushAttrib(GL_LIST_BIT);
        glListBase(ListBase);
        glCallLists(1, GL_UNSIGNED_BYTE, &letter[0]);
    glPopAttrib();
    if (ALPHA_TEST_ON) { glEnable(GL_ALPHA_TEST); }
    if (LIGHT_ON) { glEnable(GL_LIGHTING); }
}

void DrawFire(IN long nrange,  // Range on y Axis
              IN long ny,      // Start on y Axis
              IN float sXPos,   // on Screen Position x
              IN float sYPos,   // on Screen Position y
              IN float sZPos) { // on Screen Position z
    long xya, xyb;

    //RandomizeTimer();

    GLboolean DEPTH_TEST_ON = glIsEnabled(GL_DEPTH_TEST); if (DEPTH_TEST_ON) { glDisable(GL_DEPTH_TEST); }
    for (xya = 0; xya < 9; xya++) {
        for (xyb = nrange + ny; xyb >= ny; xyb--) {
            glLoadIdentity();
            glTranslatef(sXPos - 0.48f, 2.1f + sYPos - (xyb * 0.5f) - (xya * 1.5f), sZPos);
            glColor4f((17.1f - xyb) * 0.25f, (8.8f - (xyb * 0.5f)) * 0.33f, (0.03f - (xyb * 0.5f)) * 0.33f, (5 - (xyb * 0.2f)));
            glCallList(gP.firelist);
        }
    }
    if (DEPTH_TEST_ON) { glEnable(GL_DEPTH_TEST); }
}

void DrawVertical_B(IN GLuint ListBase, // ImageList
                    IN long xn,         // Start Character || Image
                    IN long nrange,     // Amount of Characters || Images
                    IN float sXPos,     // on Screen Position x
                    IN float sYPos,     // on Screen Position y
                    IN float sZPos) {   // on Screen Position Z
    long xy;
    if (nrange > 255) { nrange = 255; xn = 0; }
    if (xn + nrange > 255) { xn = 255 - nrange; }

    for (xy = 0; xy <= nrange; xy++) {
        glLoadIdentity();
        glTranslatef(sXPos, sYPos - xy, sZPos);
        MatrixPoint_Color4f(xn - xy);
        DrawListNumber(ListBase, g_ml[xn].letter - xy);
    }
}

void DrawVertical(IN GLuint ListBase, // ImageList
                  IN long xn,         // Start Character || Image
                  IN long nrange,     // Amount of Characters || Images
                  IN float sXPos,     // on Screen Position x
                  IN float sYPos,     // on Screen Position y
                  IN float sZPos) {   // on Screen Position z
    static float xgo, ygo, ngo;
    long xy;

    //RandomizeTimer();

    if (ngo >= 0) {
       ngo = -99.9f;
       //xgo = -25.0f + max(1.0f, rsRandf(65.0f));
       //ygo = 40 - max(1.0f, rsRandf(20.0f));
       xgo = -25.0f + rnd(1, 65);
       ygo = (float)(40 - rnd(1, 20));
    }
    if (nrange > 255) { nrange = 255; xn = 0; }
    if (xn + nrange > 255) { xn = 255 - nrange; }

    glLoadIdentity();
    for (xy = 0; xy <= nrange; xy += 2) {
        glTranslatef(sXPos, sYPos - xy, sZPos);
        MatrixPoint_Color4f(xn - xy);
        DrawTextNumber(ListBase, g_ml[xn].letter - (BYTE) xy);
        DrawFire(1, nrange + xy, sXPos, sYPos - xy, sZPos);
    }

    if (ngo >= -99.9f ) {
        glLoadIdentity();
        long first = xy;
        long last = xy + (nrange / 4) + 1;
        for (xy = first; xy < last; xy += 2) {
            glTranslatef(xgo, ygo - xy, sZPos);
            MatrixPoint_Color4f(xn - xy);
            DrawListNumber(ListBase, g_ml[xn].letter - xy);
            glLoadIdentity();
            DrawFire(1, (long)((nrange * 0.8f) + xy), sXPos, sYPos - (xy / 2.0f), sZPos);
        }
    }
    ngo += 0.01f;
}

void DrawMatrixF_A(IN GLuint ListBase) {
    long nVcount = 9;
    static long LetterPos[10][3];
    static long I, xPos, yPos, zPos, first;
    static float xni;
    long nCount;
    //RandomizeTimer();

    for (nCount = 0; nCount <= nVcount; nCount++) {
        xni += (1.0f / (float) nVcount) * 0.4f;
        if ((xni >= 300.0f) || (xPos == 0.0f) || (first < nVcount)) {
            xPos = rsRandi(60);
            yPos = -20 + rsRandi(40);
            zPos = -10 + rsRandi(30);
            if (first < nVcount) { first += 1; }
            LetterPos[I][0] = xPos;
            LetterPos[I][1] = yPos;
            LetterPos[I][2] = zPos;
            I += 1;
            if (I > nVcount) { I = 1; }
            xni = 0;
        }
        if (first == nVcount) {
            DrawVertical_B(ListBase, gP.bAlpha - LetterPos[nCount][0], (long) (xni * 0.33f), 
                           -18.0f + LetterPos[nCount][0], 45.0f + LetterPos[nCount][1] - (xni / 30.0f),
                           LetterPos[nCount][2] - 199.9f + (xni - (xni * 0.33f)) + (xni / 30.0f));
        }
    }
}

void DrawMatrixF_C(IN GLuint ListBase) {
    long nVcount = 11;
    static long LetterPos[12][3];
    static long I, xPos, yPos, zPos, first;
    static float xni;
    long Vcount;

    //RandomizeTimer();

    for (Vcount = 0; Vcount <= nVcount; Vcount++) {
        xni += (1.0f / (float) nVcount) / 6.0f;
        if (xni >= 300.0f  || xPos == 0  || first < nVcount ) {
            xPos = rsRandi(60);
            yPos = -20 + rsRandi(40);
            zPos = -10 + rsRandi(30);
            if (first < nVcount) { first += 1; }
            LetterPos[I][0] = -10 + xPos;
            LetterPos[I][1] = yPos;
            LetterPos[I][2] = zPos;
            I += 1;
            if (I > nVcount) { I = 1; }
            xni = 0;
        }
        if (first == nVcount) {
            DrawVertical_B(ListBase, gP.bAlpha - LetterPos[Vcount][0], (long) (xni / 3.0f) , 
                           -20.0f + LetterPos[Vcount][0], 30.0f + LetterPos[Vcount][1] - (xni / 30.0f),
                           LetterPos[Vcount][2] - 199.9f +(xni - (xni / 3.0f)) + (xni / 30.0f));
        }
    }
}

void DrawMatrixF_B(IN GLuint ListBase) {
    long nVcount = 9;
    static long LetterPos[10][3];
    static long I, xPos, yPos, zPos, first;
    static float xni;
    long Vcount;

    //RandomizeTimer();

    for (Vcount = 0; Vcount <= nVcount; Vcount++) {
        xni += (1.0f / (float) nVcount) * 0.25f;
        if (xni >= 250.0f || xPos == 0  || first < nVcount) {
            //xPos = max(10, rsRandi(80));
            xPos = (long) rnd(10, 80);
            yPos = -20 + rsRandi(20);
            zPos = -10 + rsRandi(100);
            if (first < nVcount) { first += 1; }
            LetterPos[I][0] = xPos;
            LetterPos[I][1] = yPos;
            LetterPos[I][2] = zPos;
            I += 1;
            if (I > nVcount) { I = 1; }
            xni = 0.0f;
        }
        if (first == nVcount) {
            DrawVertical_B(ListBase, gP.bAlpha - LetterPos[Vcount][0], (long)(xni / 2.5f), -5.0f + LetterPos[Vcount][0], 
                           25.0f + LetterPos[Vcount][1] - (xni / 25.0f), -249.9f  +LetterPos[Vcount][2] + xni + (xni / 250.0f));
        }
    }
}

void TexCoord3f(IN float ecke, IN float s1, IN float s2, IN float s3, IN long nTexture) {
    ecke *= 0.5f;
    s3 *= 0.5f;
    glBindTexture(GL_TEXTURE_2D, nTexture);
    glBegin(GL_QUADS);
        glNormal3f(0.0f, 0.0f, 1.0f);
        //Texture coordinates                                     //Vertex coordinates
        glTexCoord2f((0.0625f *(s1 + 1.0f)), (0.0625f * s2))      ; glVertex3f( ecke + s3,-ecke + s3, -ecke + s3);
        glTexCoord2f((0.0625f * s1), (0.0625f * s2))              ; glVertex3f(-ecke + s3,-ecke + s3, -ecke + s3);
        glTexCoord2f((0.0625f * s1), (0.0625f * (s2 - 1)))        ; glVertex3f(-ecke + s3, ecke + s3, -ecke + s3);
        glTexCoord2f((0.0625f *(s1 + 1.0f)), (0.0625f * (s2 - 1))); glVertex3f( ecke + s3, ecke + s3, -ecke + s3);
    glEnd();
}

ExportC long BBProc (OUT BBPLUGIN &BBP) {
    long K = 0, I = 0, it, nRet = BBP_SUCCESS;
    float fft[256], SoundBuffer[256];
    float xFrame, yFrame, rAspect;
    float camera = 0.0f, Btiming = 0.0f, t = 0.0f, pulse = 0.0f;

    static long InitDone, DepthTest, Showtimers, Showtime;
    static DWORD ADelay;
    static float Ani, Bni, Dni, Eni, Cni, tni, tx, txA;
    static BYTE lastRColor, lastGColor, lastBColor;

    static float xyzLoc[7][3];

    float sPulse, Ay, By;
    static float PulseAngle;

    switch (BBP.msg) {
    case BBP_RENDER:
        RandomizeTimer();

        t = (float)time(NULL) - Btiming;
        if (t > 1.0f) {
            Btiming = (float) time(NULL);
            if (gP.loaded) { tx -= 1.0f; }
            txA += 1.0f;
            if (tx < 0.0f) {
                tx = 99.0f;
                if (tni >= 0.0f) { tni -= 1.0f; }
            }
            if (txA > 999.0f) {
                txA = 0.0f;
                if (Showtimers < 3) { Showtimers += 1; }
            }
        }
        glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

        // Select smooth shading
        glShadeModel(GL_SMOOTH);

        glLoadIdentity();
        glPushMatrix();
            if (Showtimers == 2) { Showtimers += 1; }
            camera = (camera + GetTickCount()) * 0.04f;

            gP.nLevel = max(BBP.lpeak / 768, BBP.rpeak / 768);

            // Velocity section
            pulse = float(gP.nLevel / 28.0f);
            PulseAngle = (float) fmod(PulseAngle + pulse, 360);
            if (GetTickCount() > ADelay) {
                ADelay = GetTickCount() + 1200;
                for (it = 0; it < 6; it++) {
                     gP.bAlpha = UpDown(gP.bAlpha);
                }
                if (Showtime > 100) { Showtime = 0; xyzLoc[6][0] = -5.0f + rsRandf(10); xyzLoc[6][1] = rsRandf(10); }
            }
            if ((gP.bAlpha > 139) && (gP.nLevel > 31)) { gP.bAlpha -= (BYTE)(pulse * 4); }

            MoveMemory(&fft[0], BBP.fftdata, 256 * sizeof(float));
            // Try and smooth out the buffer by averaging the last results:
            for (K = 0; K < 256; K++) {
                 // We use SQR to bring out the midtone of the music, otherwise the spectrum is very flat.
                 SoundBuffer[K] = (float)(sqrt(sqrt(fft[K]) * 2.0f));
            }

            K = (long) pulse * 10;
            if ((gsR[gP.nLevel] / SoundBuffer[K]) * 0.5f < 255) {
                gP.bRed = 1 + (BYTE)((gsR[gP.nLevel] / SoundBuffer[K]) / 2);
                lastRColor = gP.bRed;
            } else {
                gP.bRed = lastRColor;
            }
            if ((gsG[gP.nLevel] / SoundBuffer[K]) * 0.5 < 255) {
                gP.bGreen = 2 + (BYTE)((gsG[gP.nLevel] / SoundBuffer[K]) / 2);
                lastGColor = gP.bGreen;
            } else {
                gP.bGreen = lastGColor;
            }
            if ((gsB[gP.nLevel] / SoundBuffer[K]) * 0.5 < 255) {
                gP.bBlue = 1 + (BYTE)((gsB[gP.nLevel] / SoundBuffer[K]) / 2);
                lastBColor = gP.bBlue;
            } else {
                gP.bBlue = lastBColor;
            }

            DepthTest = glIsEnabled(GL_DEPTH_TEST); if (DepthTest) { glDisable(GL_DEPTH_TEST); }

            glLoadIdentity();
            glPushMatrix();
                 glTranslatef(0.0f, 0.0f, 0.8f);
                 glBindTexture(GL_TEXTURE_2D, gP.mt[2].Texture);
                 glColor4ub(gnR[gP.nLevel], gnG[gP.nLevel], gnB[gP.nLevel], 128);
                 DrawBackground(pulse);
                 RGBASquare(1.0f, 90, 45, 109 , 16 + gP.bRed, 16 + gP.bGreen, 16 + gP.bBlue, gP.bAlpha);

                 glTranslatef(0.0f, 106.5f, 0.8f);
                 sPulse = -500.0f + pulse * 20;
                 glBindTexture(GL_TEXTURE_2D, gP.mt[3].Texture);
                 for (long KK = 0; KK < 3; KK++) {
                     K = max((KK * 16) -1, 0);
                     glPushMatrix();
                         glRotatef(PulseAngle * K, 0.0f, 0.0f, 1.0f);
                         Ay = (float)(2 + SoundBuffer[K] * (50.0f + K / 255.0f * 70.0f)); // As K increases, the relative size of the signal
                         By = Ay;
                         glColor4f(gfR[K] * SoundBuffer[K] + 0.2f, gfG[K] * SoundBuffer[K] + 0.2f, gfB[K]* SoundBuffer[K], 0.7f);
                         glBegin(GL_QUADS);
                             glTexCoord2f(0.0f, 0.0f); glVertex3f(-By , Ay, sPulse);
                             glTexCoord2f(1.0f, 0.0f); glVertex3f( By , Ay, sPulse);
                             glTexCoord2f(1.0f, 1.0f); glVertex3f( By ,-Ay, sPulse);
                             glTexCoord2f(0.0f, 1.0f); glVertex3f(-By ,-Ay, sPulse);
                         glEnd();
                     glPopMatrix();
                 }
            glPopMatrix();

            if (DepthTest) { glEnable(GL_DEPTH_TEST); }

            glLoadIdentity();
            glPushMatrix();
                 glBindTexture(GL_TEXTURE_2D, gP.mt[0].Texture);
                 if ((gP.bAlpha < 130) && (gP.loaded) && (gP.nLevel < 3)) {
                     Set3D_Matrix(gP.charlist, camera, 2, -1000, txA);
                 } else if ((gP.loaded == 0) && (gP.nLevel <= 3)) {
                     Set3D_Matrix(gP.charlist, camera, gP.nLevel, -1000, txA);
                 } else if (((gP.bAlpha > 129) && (gP.loaded)) || (gP.nLevel > 1)) {
                     Set3D_Matrix(gP.charlist, camera, gP.nLevel, -1000, txA);
                 }
                 glFlush();
            glPopMatrix();

            if ((Ani >= 1.0f) || (Bni >= 0.2f)) {
                Ani = 1.0f + (txA * 0.35f);
                if ((Ani > 350.0f) || (xyzLoc[0][1] == 0)) {
                    //Ani = 1.0f + (txA * 0.35f); xyzLoc[0][0] = max(1.0f, rsRandf(60.0f)); xyzLoc[0][1] = max(1.0f, rsRandf(20.0f));
                    Ani = 1.0f + (txA * 0.35f); xyzLoc[0][0] = (float)rnd(1, 60); xyzLoc[0][1] = (float)rnd(1, 20);
                }
                glLoadIdentity();
                glPushMatrix();
                     DrawVertical_B(gP.charlist, gP.bAlpha, (long) (Ani / 3.5f), -10.0f + xyzLoc[0][0], 20.0f + xyzLoc[0][1] - (Ani / 50.0f), (gP.fzoom * 3.5f) + Ani);
                     if ((tni < 0) && (xyzLoc[0][1] != 0)) {
                         DrawMatrixF_A(gP.charlist);
                     }
                     if (Ani > 175 && Showtimers > 1 || Bni >= 0.2f) {
                         Bni = 0.2f + (txA * 0.32f * 0.20f);
                         if (Bni > 320 || xyzLoc[1][1] == 0) {
                             //Bni = 0.2f + (txA * 0.32f * 0.20f); xyzLoc[1][0] = rsRandf(40); xyzLoc[1][1] = max(2, rsRandf(20));
                             Bni = 0.2f + (txA * 0.32f * 0.20f); xyzLoc[1][0] = rsRandf(40); xyzLoc[1][1] = (float)rnd(2, 20);
                         }
                         glLoadIdentity();
                         DrawVertical_B(gP.charlist, gP.bAlpha, long (Bni * 0.5f), -25.0f + xyzLoc[1][0], 10.0f + xyzLoc[1][1] - (Bni / 50.0f), (gP.fzoom * 3.2f) + Bni * 5);
                         DrawMatrixF_C(gP.charlist);
                     }
                     glFlush();
                glPopMatrix();
            }

            if (Showtimers > 1 || Cni >= 0.5f  || Dni >= 0.5f) {
                Cni = 1 + (txA * 0.3f);
                if (Ani == Cni || Bni == Cni) { Cni -= 0.5f; }
                if (Cni > 300 || xyzLoc[2][1] == 0) {
                    //Cni = 1 + (txA * 0.3f); xyzLoc[2][0] = max(20, rsRandf(65)); xyzLoc[2][1] = rsRandf(15);
                    Cni = 1 + (txA * 0.3f); xyzLoc[2][0] = (float)rnd(20, 65); xyzLoc[2][1] = rsRandf(15);
                }
                glLoadIdentity();
                glPushMatrix();
                     DrawVertical_B(gP.charlist, gP.bAlpha, (long)(Cni / 3.0f), -15.0f + xyzLoc[2][0], 20.0f + xyzLoc[2][1] - (Cni / 50.0f), (gP.fzoom * 2.0f) + Cni - (Cni / 3.0f));
                     if ((tni < 0) && (xyzLoc[2][1] != 0)) {
                         DrawMatrixF_B(gP.charlist);
                     }
                     if (Cni > 180 || Dni >= 0.25f) {
                         Dni = Dni + 0.75f;
                         Eni = 1 + (txA * 0.25f);
                         if (Ani == Dni || Dni == Eni) { Dni -= 0.5f; }
                         if (Dni > 360.0f || xyzLoc[3][1] == 0) {
                             Dni = 0.75f; xyzLoc[3][0] = rsRandf(65); xyzLoc[3][1] = rsRandf(20);
                         }
                         if (Ani == Dni) {
                             Ani += 0.5f; 
                             if (Dni == Eni) { Eni += 0.5f; }
                         }
                         if (Eni > 250 || xyzLoc[4][1] == 0) {
                             Eni = 1 + (txA * 0.25f); xyzLoc[4][0] = rsRandf(65); xyzLoc[4][1] = rsRandf(20);
                         }
                         glLoadIdentity();
                         glPushMatrix();
                             DrawVertical(gP.charlist, gP.bAlpha / 2, (long)(Dni / 3.6f), -25.0f + xyzLoc[3][0], 10.0f + xyzLoc[3][1] - (Dni * 0.02f), (gP.fzoom * 1.2f) +(Dni * 0.33f));
                             DrawVertical_B(gP.charlist, gP.bAlpha, (long)(Eni / 2.5f), -30.0f + xyzLoc[4][0], 15.0f + xyzLoc[4][1] - (Eni * 0.02f), (gP.fzoom * 2.5f) + Eni);
                             glFlush();
                         glPopMatrix();
                         glFlush();
                     }
                glPopMatrix();
            }
            Showtime += 1;
            glFlush();

        glPopMatrix();
        glFlush();

        // Very important we must reassignBBP.RC to the new BBP.DC
        // Note: don//t use permanent DC, this produce better and smoother display
        wglMakeCurrent(BBP.dc, BBP.rc);
        break;

    case BBP_CREATE:
        // Retrieve plugin details
        strcpy(BBP.title, "Matrix");
        strcpy(BBP.author, "Jrgen Huhn & Patrice Terrier");
        BBP.version  = MAKEWORD(3, 0); // Version 3.0"
        BBP.renderto = BBP_OPENGL;     // or BBP_GDIPLUS, or BBP_DIRECTX
        break;

    case BBP_INIT:
        // Set the static flag
        InitDone = 1;

        // Clear the screen buffer
        glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
        glLoadIdentity();
        glClearColor((GetRValue(BBP.backargb) + 1) / 256.0f, (GetGValue(BBP.backargb) + 1) / 256.0f, (GetBValue(BBP.backargb) + 1) / 256.0f, 1.0f);
        glShadeModel(GL_SMOOTH);
        glEnable(GL_DEPTH_TEST);
        glClearDepth(1.0);        // Depth Buffer Setup
        glDepthFunc(GL_LESS);     // GL_EQUAL The Type Of Depth Test To Do
        glEnable(GL_BLEND);

        glBlendFunc(GL_ONE, GL_ONE);

        glAlphaFunc(GL_GREATER, 0.1f);
        glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
        glHint(GL_FOG_HINT,GL_FASTEST);
        glEnable(GL_TEXTURE_2D);

        Path_Combine(gP.mt[0].FullName, TexturePath(), L"MatrixFt.png"); gP.mt[0].ID = 1; gP.mt[0].Square = 0;
        Path_Combine(gP.mt[1].FullName, TexturePath(), L"Star2.jpg"); gP.mt[1].ID = 2; gP.mt[1].Square = 0;
        Path_Combine(gP.mt[2].FullName, TexturePath(), L"Matrix.png"); gP.mt[2].ID = 3; gP.mt[2].Square = 0;
        Path_Combine(gP.mt[3].FullName, TexturePath(), L"Flare0.jpg"); gP.mt[3].ID = 4; gP.mt[3].Square = 0;
        MakeMultipleTexture(&gP.mt[0], 4);

        ColorInitFloat();
        glEnable(GL_TEXTURE_2D);
        // Storage for 256 characters
        gP.charlist = glGenLists(256);
        xFrame = 0; yFrame = 0;
        for (I = 0; I < 256; I++) {
            if (xFrame == 17) { xFrame = 0; yFrame += 1; }
            glNewList(gP.charlist + I, GL_COMPILE);
                TexCoord3f(1.0f, xFrame, yFrame, 1.0f, gP.mt[0].Texture);
            glEndList();
            xFrame += 1;
        }
        // Done building the display list

        xFrame = 0; yFrame = 0;

        gP.firelist = glGenLists(2);
        glNewList(gP.firelist, GL_COMPILE);
            DrawQuad(1.0f, 1.0f, 1.0f, gP.mt[1].Texture);
        glEndList();

        ADelay = GetTickCount() + 200;
        Btiming = (float)time(NULL);
        gP.bAlpha = 155;
        gP.fzoom = -99.9f;
        tni = 10;
        gP.loaded = 0;

        ColorInit();
        MakeColorLUT();
        MakeColorFLUT();
        break;

    case BBP_SIZE:
        // The size of the view port has changed.
        RECT rc; GetClientRect(BBP.parent, &rc);
        glViewport(0, 0, Width(rc), Height(rc));

        glMatrixMode(GL_PROJECTION);
        glLoadIdentity();
        rAspect = 0.0f;
        if (Height(rc)) { rAspect = (float) Width(rc) / (float) Height(rc); }
        gluPerspective(45.0f, rAspect, 0.1f, 1000.0f);
        glMatrixMode(GL_MODELVIEW);
        break;

    case BBP_DESTROY:
        if (InitDone) { // This static flag is set only when the BBP_INIT has been fired
            if (!gP.bailout) {
                gP.bailout = !gP.bailout;
                Sleep(500);

                DestroyTexture (&gP.mt[0], 4);
                if (glIsList(gP.charlist)) { glDeleteLists(gP.charlist, 256); }
                if (glIsList(gP.firelist)) { glDeleteLists(gP.firelist ,2); }
            }
        }
        break;

    default:
        nRet = BBP_ERROR;
        break;
    }
    return nRet;
}

BOOL WINAPI DllMain (HINSTANCE hinstDLL, IN DWORD fdwReason, IN LPVOID lpvReserved) {
    switch (fdwReason) {
    case DLL_PROCESS_ATTACH:
        break;
    case DLL_PROCESS_DETACH:
        break;
    case DLL_THREAD_ATTACH:
        break;
    case DLL_THREAD_DETACH:
        break;
    }
    return TRUE;
}
