//+--------------------------------------------------------------------------+
//|                                                                          |
//|                                Oscillo                                  |
//|                          BassBox OpenGL plugin                           |
//|                                                                          |
//|                              Version 2.00                                |
//|                                                                          |
//+--------------------------------------------------------------------------+
//|                                                                          |
//|                         Author Patrice TERRIER                           |
//|                                                                          |
//|                         copyright(c) 2007-2017                           |
//|                                                                          |
//|                Patrice Terrier http://www.zapsolution.com                |
//|                                                                          |
//+--------------------------------------------------------------------------+
//|                  Project started on : 10-30-2007 (MM-DD-YYYY)            |
//|                        Last revised : 02-14-2017 (MM-DD-YYYY)            |
//+--------------------------------------------------------------------------+
//#include <windows.h>
//#include <gl/GL.h>
//#include <gl/GLU.h>
//#include <math.h>

#include <windows.h>
//#include "..\TCLib\stdio.h"
//#include "..\TCLib\string.h"
//#include "..\TCLib\stdlib.h"
//#include "..\TCLib\memory.h"
//#include "..\TCLib\malloc.h"
#include "..\TCLib\math.h"
//#include "..\TCLib\tchar.h"
#include "..\TCLib\Strings.cpp"

#include <gl/GL.h>
#include <gl/GLU.h>
#include "gl2.h"

typedef ULONGLONG QWORD;
#include "BBplugin.h"
#define ExportC extern "C" _declspec (dllexport)

long g_color[32];
GLubyte gnR[32], gnG[32], gnB[32];

void bbp_ColorInit() {
    g_color[0]  = bbpARGB(255, 0,44,233);
    g_color[1]  = bbpARGB(255, 0,67,210);
    g_color[2]  = bbpARGB(255, 0,89,187);
    g_color[3]  = bbpARGB(255, 0,112,164);
    g_color[4]  = bbpARGB(255, 0,135,142);
    g_color[5]  = bbpARGB(255, 0,159,117);
    g_color[6]  = bbpARGB(255, 0,183,88);
    g_color[7]  = bbpARGB(255, 0,207,58);
    g_color[8]  = bbpARGB(255, 0,231,29);
    g_color[9]  = bbpARGB(255, 26,234,26);
    g_color[10] = bbpARGB(255, 52,237,23);
    g_color[11] = bbpARGB(255, 79,240,20);
    g_color[12] = bbpARGB(255, 105,243,17);
    g_color[13] = bbpARGB(255, 126,245,14);
    g_color[14] = bbpARGB(255, 147,248,11);
    g_color[15] = bbpARGB(255, 168,250,8);
    g_color[16] = bbpARGB(255, 189,253,5);
    g_color[17] = bbpARGB(255, 210,255,2);
    g_color[18] = bbpARGB(255, 233,255,0);
    g_color[19] = bbpARGB(255, 255,255,0);
    g_color[20] = bbpARGB(255, 255,251,0);
    g_color[21] = bbpARGB(255, 255,235,0);
    g_color[22] = bbpARGB(255, 255,215,0);
    g_color[23] = bbpARGB(255, 255,196,0);
    g_color[24] = bbpARGB(255, 255,176,0);
    g_color[25] = bbpARGB(255, 255,156,0);
    g_color[26] = bbpARGB(255, 253,137,0);
    g_color[27] = bbpARGB(255, 255,117,0);
    g_color[28] = bbpARGB(255, 255,97,0);
    g_color[29] = bbpARGB(255, 255,78,0);
    g_color[30] = bbpARGB(255, 255,58,0);
    g_color[31] = bbpARGB(255, 255,0,0);
}

void MakeColorLUT() {
    COLORBYTES bytestruct;
    for (long K = 0; K < 32; K++) {
        MoveMemory(&bytestruct, &g_color[K], sizeof(COLORBYTES));
        gnR[K] = bytestruct.R;
        gnG[K] = bytestruct.G;
        gnB[K] = bytestruct.B;
    }
}

ExportC long BBProc (OUT BBPLUGIN &BBP) {
    long percent, K, nRet = BBP_SUCCESS;
    BYTE color = 0;
    static BBPTEXTURE mt;
    short ndata = 0;
    static float MultiplanIndex[101];

    static float vf[128][101][2]; // audio frames
    static long stt;              // index to most distant + 2
    static float PulseAngle;

    float pulse, rAspect;

    switch (BBP.msg) {
    case BBP_RENDER:
        // Draw the scene
        long I, J, ColorRange;
        BYTE Fading;

        // Velocity section
        pulse = (float)(max(BBP.lpeak / 700.0f, BBP.rpeak / 700.0f) / 28.0f);
        PulseAngle = (float)fmod(PulseAngle + pulse, 360.0f);

        glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
        glLoadIdentity();

        GL_LookAt (0.0f, 0.0f, 19.0f, 0.0f, 0.0f, 0.0f, 0.0f, 1.0f, 0.0f);
        glTranslatef(0.0f, 0.22f, 0.0f); // 02-18-2017

        // CARTESIAN ARRAY
        float UseSize, Multiplan, zS;
        glPushMatrix();
           J = 100;
           I = J + 2;
           while (TRUE) {
               I -= 2; if (I < 0) { break; }
               MultiplanIndex[I] += 1.0f; // 0.75 '0.5'0.2'02 ' speed
               if (MultiplanIndex[I] > J) { MultiplanIndex[I] = 0; stt = I; } // recycle
           }
           I = J + 2;
           while (TRUE) {
               // Rendering from furthest to nearest (ascending Z order)
               I -= 2; if (I < 0) { break; }
               stt -= 2; if (stt < 0) { stt = J; } // loop round
               Multiplan = MultiplanIndex[stt];    // furthest away first
               if (Multiplan == 0) {
                   for (K = 0; K < 128; K++) {
                       // WIM MAGIC!
                       // BBP.WIMdata returns a pointer to an area of memory
                       // containing an array of 256 short integer.
                       // Warning, the Left and Right audio channels are mixed together
                       // thus we step 4, to consider only one channel.
                       MoveMemory(&ndata, BBP.wimdata + K * 4, 2);
                       vf[K][stt][0] = (float)((float)ndata / 32767.0f);
                       MoveMemory(&ndata, BBP.wimdata + 2 + K * 4, 2);
                       vf[K][stt][1] = (float)((float)ndata / 32767.0f);
                   }
               }

               UseSize = 2.0f;             // Size
               zS = -Multiplan * 0.03125f; // Z spacing

               if (Multiplan < 30.0f) { // detail
                   glEnable(GL_LINE_SMOOTH);
                   Fading = (BYTE)(min(2.0f / Multiplan, 1.0f) * 255.0f);

                   glLineWidth(max(Multiplan / 2.0f, 2.0f));

                   // Draw left channel
                   glPushMatrix();
                       percent = (long)((BBP.mediapos * 100) / BBP.medialength);
                       if (percent > 99) { PulseAngle = 0; }
                       if ((percent < 33) || (percent > 66)) {
                           glRotatef(-PulseAngle, 1.0f, 0.0f, 0.0f);
                       } else {
                           glRotatef(-PulseAngle, 0.0f, 1.0f, 0.0f);
                       }
                       glTranslatef(0.0f, -0.25f, 0.0f);
                       glBegin(GL_LINES);
                       for (K = 0; K < 127; K++) {
                           // color range must fit between 0-32
                           ColorRange = (long) (17 + (vf[K][stt][0] / 0.09375f));
                           if (Multiplan > 0) { ColorRange = ColorRange / 2; }
                           glColor4ub(gnR[ColorRange], gnG[ColorRange], gnB[ColorRange], Fading);
                           glVertex3f(-UseSize + UseSize * K / 64.0f, vf[K][stt][0], zS);
                           glVertex3f(-UseSize + UseSize *(K + 1) / 64.0f, vf[K + 1][stt][0], zS);
                       }
                       glEnd();
                   glPopMatrix();

                   // Draw right channel
                   glPushMatrix();
                       if ((percent < 33) || (percent > 66)) {
                           glRotatef(PulseAngle, 1.0f, 0.0f, 0.0f);
                       } else {
                           glRotatef(PulseAngle, 0.0f, 1.0f, 0.0f);
                       }
                       glTranslatef(0.0f, 0.25f, 0.0f);
                       glBegin(GL_LINES);
                       for (K = 0; K < 127; K++) {
                           // color range must fit between 0-32
                           ColorRange = (long) (17 + (vf[K][stt][1] / 0.09375f));
                           glColor4ub(gnR[ColorRange], gnG[ColorRange], gnB[ColorRange], Fading);
                           glVertex3f(-UseSize + UseSize * K / 64.0f, vf[K][stt][1], zS);
                           glVertex3f(-UseSize + UseSize * (K + 1) / 64.0f, vf[K + 1][stt][1], zS);
                       }
                       glEnd();
                    glPopMatrix();

               }
           }
        glPopMatrix();

        glFlush();

        // Very important we must reassign BBP.RC to the new BBP.DC
        // Note: don't use permanent DC, this produce better and smoother display
        wglMakeCurrent(BBP.dc, BBP.rc);
        break;

    case BBP_CREATE:
        // Retrieve plugin details
        strcpy(BBP.title, "Oscilloscope");
        strcpy(BBP.author, "Patrice Terrier");
        BBP.version  = MAKEWORD(1, 0); // Version 1.0"
        BBP.renderto = BBP_OPENGL;     // or BBP_GDIPLUS, or BBP_DIRECTX
        break;

    case BBP_INIT:
        // Do your code initialisation there     
        bbp_ColorInit();

        glClearColor((GetRValue(BBP.backargb) + 1) / 256.0f, (GetGValue(BBP.backargb) + 1) / 256.0f, (GetBValue(BBP.backargb) + 1) / 256.0f, 1.0f);

        for (K = 1; K < 101; K++) { MultiplanIndex[K] = (float) K; }

        glShadeModel(GL_SMOOTH);                             // Enable Smooth Shading
        glClearDepth((GLclampd) 1.0);                        // Depth Buffer Setup
        glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);   // Really Nice Perspective Calculations
        glEnable(GL_COLOR_MATERIAL);                         // Enable Coloring Of Material
        glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);   // Enable Alpha Blending
        glEnable(GL_BLEND);                                  // Enable Blending
        glEnable(GL_ALPHA_TEST);                             // Enable Alpha Testing
        glAlphaFunc(GL_ALWAYS, 0.0f) ;                       // Set Alpha Testing

        MakeColorLUT();
        break;

    case BBP_SIZE:
         // The size of the view port has changed.
        RECT rc; GetClientRect(BBP.parent, &rc);
        glViewport(0, 0, Width(rc), Height(rc));

        glMatrixMode(GL_PROJECTION);
        glLoadIdentity();
        rAspect = 0.0f;
        if (Height(rc)) { rAspect = (float) Width(rc) / (float) Height(rc); }
        GL_Perspective(7.0f, rAspect, 1.0f, 100.0f);
        glMatrixMode(GL_MODELVIEW);
        break;

    case BBP_DESTROY:
        // Free up your resources there
        break;

    default:
        nRet = BBP_ERROR;
        break;
    }
    return nRet;
}
